from globals import *
from global_defines import VR_Fire_Modes_Switches
import globals
import debug
import object
import system
import dialog
import sys
import helpfile
import timerepr

__doc__= """this module contains custom configuration that every scripter/tester can set
for himself.
it should NEVER get commited and should only be used locally.

you can copy localinit_example.py to have a framework to start with.
"""
VR_Help_Menu = 72 # H
VR_F11 = 122
VR_Esc = 27
VR_Teleport = 84 # T
VR_Shift = 16 
VR_Ctrl = 17
VR_Alt = 18
AVR_Alternatives = [ VR_Shift, VR_Ctrl, VR_Alt ]
PASS_TIME = "00:00:10"

def Was_Pressed_Before ( Button ):
	"""
	If button was pressed not far as PASS_TIME milliseconds from current keypress, it return TRUE,
	so it made possible to use Alt-key, Ctrl-Key and Shift-key combinations.
"""
	if not hasattr (data(), "alt_button") or not hasattr (data(), "act_time") or data().alt_button != Button :
		return False
	act_time = system.get_mission_time()
	elapsed_time = act_time - data().act_time
	if elapsed_time < timerepr.time( PASS_TIME ):
		return True
	return False	

def CheckFlag():
	if not system.get_app_state()==globals.APP_GAME and not data().AR_Console_Is_Opened :
		return False
	if not hasattr( data(), "Weapon_Modes_Flag" ):
		return True
	return data().Weapon_Modes_Flag

def on_button_down(Button):
	"""is called when the player presses a key
	
returns True if this function has handled the key and no further action for this
key should be executed.
returns False if the programm should handle the key and execute the default
action for this key (if there is any).

Button is a "Virtual Key Code", an integer.
F1-F12 = 112-123 
"""
	# print Button

	if not hasattr(data(), "AR_Console_Is_Opened"):
		data().AR_Console_Is_Opened = False

	if system.get_app_state()==globals.APP_GAME and AVR_Alternatives.count(Button) :
		data().act_time = system.get_mission_time()
		data().alt_button = Button
	elif CheckFlag() and Was_Pressed_Before ( VR_Ctrl ) :
		data().Weapon_Modes_Flag = False
		Something_Was_Done = True
		if Button==VR_Help_Menu :
			helpfile.Help_menu()
		elif Button in VR_Fire_Modes_Switches :
			for pc in system.get_selected_pcs():
				character.Mode_Switch( pc, VR_Fire_Modes_Switches[Button] )
		elif (Button==VR_Teleport):
			system.Teleport_To_Car()
		else:
			Something_Was_Done = False
		data().alt_button = 0 
		data().Weapon_Modes_Flag = True
		if Something_Was_Done: return True
	elif (Button==VR_F11):
		data().AR_Console_Is_Opened = not data().AR_Console_Is_Opened
	elif (Button==VR_Esc):	
		if data().AR_Console_Is_Opened:
			data().AR_Console_Is_Opened = False
	
	# key unhandled, let the application handle the key
	return False


