# -*- coding: utf-8 -*-
from global_defines import *
import dialogs
import npc
import water
import object_events
from const import *
import schedules
from dynamic_camera import *
import math
import enemy_script
import char_autogeneration
import comments
import skies
import sounds
from daily_routine import *
import dialog
import spawnanimals

#*** actual revison: Revision 58, 17.08.2004 ***********************************

# äöü (better)

def initParties():
	system.create_party(id="UISPIELER",type=PT_HUMAN)
	system.create_party(id="NPCS",type=PT_COMPUTER)
	system.create_party(id="ANIMALS",type=PT_COMPUTER)
	system.create_party(id="RATSKULLS",type=PT_COMPUTER)

def GetZoneEnterLocation(enterdirection):
	start_locations = \
		{	"NORTH":	(301.89, 266.89),
	 		"SOUTH":	(412.0, 774.0),
	 		"WEST":		(217.0, 469.0),
	 		"EAST":		(586.0, 549.0),
			#"EAST":		(586.0, 549.0)
			
	 	}
	if (enterdirection in start_locations.keys()):
		return start_locations[enterdirection]
	else:
		raise ValueError, "no spawn location for this direction registered: " + enterdirection
def GetZoneEnterLocationVehicles(enterdirection):
	start_locations = \
		{	"NORTH":	(299.57, 285.57),
	 		"SOUTH":	(408.12, 779.73),
	 		"WEST":		(229.36, 470.05),
	 		"EAST":		(576.05, 555.66),
			#"EAST":		(586.0, 549.0)
	 	}
	if (enterdirection in start_locations.keys()):
		return start_locations[enterdirection]
	else:
		raise ValueError, "no spawn location for this direction registered: " + enterdirection

def on_init():
	skies.init_sky_preset("orange")

## init objects that are modified by script
def initScriptUseObjects():
	
	#anderes
	system.mark_for_script_use("ZONE_3_BUILDING_685")
	
	system.mark_for_script_use(data().Obj_Bunker1)
	system.mark_for_script_use("BUILDING_2552")
	system.mark_for_script_use("BUILDING_2768")
	
	# bonfires - for cooking
	system.mark_for_script_use('BUILDING_1133')
	system.mark_for_script_use('BUILDING_1590')
	# windrad
	system.mark_for_script_use("BUILDING_502")
	system.mark_for_script_use("BUILDING_363")
	
	#stein der das rslager sperrt
	system.mark_for_script_use("BUILDING_13097")
	objects.set_active_state("ZONE_3_BUILDING_13097", INACTIVE)

	#kisten, truhen, tresore
	system.mark_for_script_use("BUILDING_7824")
	
	system.mark_for_script_use("BUILDING_15361")
	system.mark_for_script_use("BUILDING_7796")
	system.mark_for_script_use("BUILDING_15363")
	system.mark_for_script_use("BUILDING_15366")
	system.mark_for_script_use("BUILDING_15379")
	system.mark_for_script_use("BUILDING_15382")
	system.mark_for_script_use("BUILDING_15411")
	system.mark_for_script_use("BUILDING_15439")
	system.mark_for_script_use("BUILDING_15440")
	system.mark_for_script_use("BUILDING_15441")
	
	# tresor im bunker
	objects.add_closed_lock(data().Obj_KisteLuke, "lock1", closure_type='normal')
	
	# Bienenstöcke Zone 3
	system.mark_for_script_use('BUILDING_15559')
	system.mark_for_script_use('BUILDING_15557')
	system.mark_for_script_use('BUILDING_15555')
	system.mark_for_script_use('BUILDING_15556')

	objects.create_item_in_inventory( 'BUILDING_15559', equipment=[ 'SET_BEESWAX' ] )
	objects.create_item_in_inventory( 'BUILDING_15557', equipment=[ 'SET_BEESWAX', 'SET_BEESWAX' ] )
	objects.create_item_in_inventory( 'BUILDING_15555', equipment=[ 'SET_BEESWAX' ] )
	
	# Berkwerk
	system.mark_for_script_use('ZONE_3_BUILDING_15741')
	
	# zäune ausschalten
	for fence in WAFFENLAGER_ZAUN:
		system.mark_for_script_use(fence)
		objects.set_attribute(fence,"climbing_allowed",False)

def init_non_rest_areas():
	data("rest").non_rest_areas = []
	if not hasattr(data(), "has_non_rest_areas"):
		data().has_non_rest_areas = True
		#spezielle non rest regionen
		system.add_region("Dorf",590,620,445,780)
		system.add_region("Distillery",525,385,570,420)
		system.add_region("Waffenlager2",445,265,550,205)
		system.add_region("Bauernhof",235,395,350,465)
		system.add_region("Einsiedler",530,525,580,560)
		system.add_region("Gonzos_Feld",245,595,340,695)
	
	data("rest").non_rest_areas.append("Dorf")
	data("rest").non_rest_areas.append("Distillery")
	data("rest").non_rest_areas.append("Waffenlager")
	data("rest").non_rest_areas.append("Bauernhof")
	data("rest").non_rest_areas.append("Einsiedler")
	data("rest").non_rest_areas.append("Gonzos_Feld")
	
	#minenfelder
	data("rest").non_rest_areas.append("MINEFIELD1")
	data("rest").non_rest_areas.append("MINEFIELD2")
	data("rest").non_rest_areas.append("MINEFIELD3")
	data("rest").non_rest_areas.append("MINEFIELD4")
	data("rest").non_rest_areas.append("MINEFIELD5")
	data("rest").non_rest_areas.append("MINEFIELD6")
	data("rest").non_rest_areas.append("MINEFIELD7")
	data("rest").non_rest_areas.append("MINEFIELD8")
	data("rest").non_rest_areas.append("MINEFIELD9")
	data("rest").non_rest_areas.append("MINEFIELD9a")
	data("rest").non_rest_areas.append("MINEFIELD9b")
	data("rest").non_rest_areas.append("MINEFIELD10")
	data("rest").non_rest_areas.append("MINEFIELD11")
	data("rest").non_rest_areas.append("MINEFIELD12")
	data("rest").non_rest_areas.append("MINEFIELD13")
	data("rest").non_rest_areas.append("MINEFIELD14")
	data("rest").non_rest_areas.append("MINEFIELD15")

def on_map_loaded():
	init_data()
	initParties()
	# place transfer vehicles
	location = GetZoneEnterLocationVehicles( system.zone_transfer_get_direction() )
	system.zone_transfer_place_vehicles( location[0], location[1] )
	location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
	system.zone_transfer_place_characters( location[0], location[1] )

	import debug; debug.cheat_party(party=False, x=location[0], y=location[1])

	npc.initNPCS()
	npc.initAnimals()
	char_autogeneration.init_mercenary('MERCENARY_HENRY')
	initItems()
	initHerbs()
	initAggro()
	initExitZones()
	initFX()
	initMinimapMarkers()
	initEquipment()
	
	on_timer(data().Timer_SpawnTimeChecker)
	#system.notify_timer(data().Timer_SpawnTimeChecker,data().Timervalue_SpawnTimeChecker)
	
	system.notify_timer(data().Timer_TiereAergern,data().Timervalue_TiereAergern)
	init_character_states()
	# wer war denn das? - > check = system.register_qb_entry('QB_006')
	# data().QB_001 = system.register_qb_entry('ZONE3_AIM_01')						#Text fuer Questbook Eintrag registrieren
	data().QB_002 = system.register_qb_entry('ZONE3_AIM_02', id_history = 'ZONE2_AIM_13')
	data().QB_003 = system.register_qb_entry('ZONE3_AIM_03', id_history = 'ZONE2_AIM_13')
	data().QB_004 = system.register_qb_entry('ZONE3_AIM_04', id_history = 'ZONE2_AIM_13')
	data().QB_005 = system.register_qb_entry('ZONE3_AIM_05', id_history = 'ZONE3_AIM_05')
	data().QB_006 = system.register_qb_entry('ZONE3_AIM_06', id_history = 'ZONE3_AIM_06')
	data().QB_007 = system.register_qb_entry('ZONE3_AIM_07', id_history = 'ZONE3_AIM_06')
	data().QB_008 = system.register_qb_entry('ZONE3_AIM_08', id_history = 'ZONE3_AIM_08')
	data().QB_009 = system.register_qb_entry('ZONE3_AIM_09', id_history = 'ZONE3_AIM_08')
	data().QB_010 = system.register_qb_entry('ZONE3_AIM_10', id_history = 'ZONE3_AIM_10')
	data().QB_011 = system.register_qb_entry('ZONE3_AIM_11', id_history = 'ZONE3_AIM_11')
	data().QB_012 = system.register_qb_entry('ZONE3_AIM_12', id_history = 'ZONE3_AIM_11')
	data().QB_013 = system.register_qb_entry('ZONE3_AIM_13', id_history = 'ZONE3_AIM_13')
	data().QB_014 = system.register_qb_entry('ZONE3_AIM_14', id_history = 'ZONE3_AIM_13')
	data().QB_015 = system.register_qb_entry('ZONE3_AIM_15', id_history = 'ZONE3_AIM_15')
	data().QB_016 = system.register_qb_entry('ZONE3_AIM_16', id_history = 'ZONE3_AIM_15')
	data().QB_017 = system.register_qb_entry('ZONE3_AIM_17', id_history = 'ZONE3_AIM_17')
	data().QB_018 = system.register_qb_entry('ZONE3_AIM_18', id_history = 'ZONE3_AIM_06')
	data().QB_019 = system.register_qb_entry('ZONE3_AIM_19', id_history = 'ZONE3_AIM_19')
	data().QB_020 = system.register_qb_entry('ZONE3_AIM_20', id_history = 'ZONE3_AIM_19')
	data().QB_021 = system.register_qb_entry('ZONE3_AIM_21', id_history = 'ZONE3_AIM_19')
	data().QB_022 = system.register_qb_entry('ZONE3_AIM_22', id_history = 'ZONE3_AIM_22')
	data().QB_023 = system.register_qb_entry('ZONE3_AIM_23', id_history = 'ZONE3_AIM_22')
	data().QB_024 = system.register_qb_entry('ZONE3_AIM_24', id_history = 'ZONE3_AIM_24')
	# system.set_qb_entry_state(data().QB_001, UNCOMPLETE)					#neuen Eintrag im Questbook anzeigen

	system.add_region("MiaAndPiaAtHome", 512,705,494,718)
	system.notify_region_entered(region="MiaAndPiaAtHome", objectid="MIA")
	system.notify_region_entered(region="MiaAndPiaAtHome", objectid="PIA")
	system.add_region("GonzosFeld", 284, 656, 266, 630)
	system.notify_region_entered(region="GonzosFeld", partyid="UISPIELER")

	system.add_region("bison_escape_zone", 205,347,269,395)
	objects.set_attribute( "BISON", "escape_region", "bison_escape_zone" )
	objects.set_attribute( "BISON", "foes", ["UISPIELER"])

	system.add_region(data().Region_Destillerie, 531, 431, 577, 374)
	system.notify_region_entered(data().Region_Destillerie, partyid="UISPIELER")

	system.add_region("REGION_HUMVEE_Z3", 362.92, 770, 332.01, 745.28)
	system.notify_region_entered(region="REGION_HUMVEE_Z3", partyid="UISPIELER")
	
	#if not data().NoRatskulls:
	system.add_region("SaeuferAmFeuer", 502, 726, 514, 716)
	system.notify_region_entered(region="SaeuferAmFeuer", partyid="UISPIELER")
	system.add_region("SaeuferRatskulls", 518, 386, 588, 420)
	system.notify_region_entered(region="SaeuferRatskulls", partyid="UISPIELER")
	system.add_region("BunkerKommentar", 488, 224, 538, 262)
	system.notify_region_entered(region="BunkerKommentar", partyid="UISPIELER")
	system.add_region("GeorgsTraktor", 480, 208, 506, 238)
	
	# minenfeld
	# "Dere c'n onlie be whin t'ousand!" --- man kann ja nie genug regionen haben
	system.add_region("MINEFIELD1", 332, 0, 346, 202)
	system.add_region("MINEFIELD2", 336, 200, 360, 238)
	system.add_region("MINEFIELD3", 344, 236, 362, 258)
	system.add_region("MINEFIELD4", 358, 252, 364, 286)
	system.add_region("MINEFIELD5", 360, 280, 382, 294)
	system.add_region("MINEFIELD6", 374, 290, 388, 318)
	system.add_region("MINEFIELD7", 384, 324, 406, 314)
	system.add_region("MINEFIELD8", 400, 320, 422, 346)
	system.add_region("MINEFIELD9", 436, 356, 450, 342) # the one! abschalten nach dem kuh massaker
	system.add_region("MINEFIELD9a", 418, 356, 436, 342)
	system.add_region("MINEFIELD9b", 450, 356, 540, 342)
	system.add_region("MINEFIELD10", 566, 336, 536, 354)
	system.add_region("MINEFIELD11", 580, 314, 564, 340)
	system.add_region("MINEFIELD12", 608, 304, 578, 318)
	system.add_region("MINEFIELD13", 610, 308, 602, 282)
	system.add_region("MINEFIELD14", 608, 286, 628, 270)
	system.add_region("MINEFIELD15", 624, 272, 642, 174)
	
	for mf in ["MINEFIELD1","MINEFIELD2","MINEFIELD3","MINEFIELD4",
		"MINEFIELD5", "MINEFIELD6","MINEFIELD7","MINEFIELD8",
		"MINEFIELD9","MINEFIELD9a","MINEFIELD9b","MINEFIELD10",
		"MINEFIELD11","MINEFIELD12","MINEFIELD13","MINEFIELD14",
		"MINEFIELD15"]:
			system.notify_region_entered(region=mf, partyid = "UISPIELER")
			system.notify_region_entered(region=mf, partyid = "ANIMALS")
			#system.notify_region_entered(region=mf, objectid = "LUKE_Z3")
	
	system.add_region("MINEFIELD FIRST WARNING", 376, 456, 426, 432)
	system.notify_region_entered(region="MINEFIELD FIRST WARNING", partyid="UISPIELER")
	system.add_region("MINEFIELD SECOND WARNING", 422, 348, 464, 394)
	system.notify_region_entered(region="MINEFIELD SECOND WARNING", partyid="UISPIELER", permanent=True)

	system.add_region("MINEFIELD PATH ENTRY", 432, 354, 452, 365)
	system.notify_region_entered(region="MINEFIELD PATH ENTRY", partyid="UISPIELER")

	#else:
	#	system.add_region("Waffenlager", 448, 211, 542, 258)
	#	system.notify_region_entered(region="Waffenlager", partyid="UISPIELER")

	system.add_region("Steinbruch1", 564, 684, 580, 658)
	system.add_region("Steinbruch2", 538, 642, 564, 654)
	system.add_region("Bergtigerin", 201, 611, 241, 581)
	system.notify_region_entered(region="Bergtigerin", partyid="UISPIELER")
	
	init_bunker_destroyed()
	
	initScriptUseObjects()
	InitChestsSafes()
	initWaterResources()
	checkZoneDependencies()
	schedules.init_schedules() ## immer nach dem initQuestbook()
	init_questitems()
	anim_windrad()
	init_non_rest_areas()
	
	system.create_object('SET_HUMVEE', 345.58, 760.64, id = 'HUMVEE_Z3', direction = 45)
	objects.set_attribute('HUMVEE_Z3', 'accepted_drivers', ['UISPIELER'])
	
	objects.set_active_state("DONALD RUMS", 0)
	
	#bunker interieur verschieben
	init_destroy_bunker_reposition_interior()
	init_main_npcs()
	
	check_ratskulls_dead()
	check_no_gno()
	

def init_bunker_destroyed():
	system.create_object("RES3D_TRES_OBJECTS_BUILDING_BUNKER_L_DESTROY",
		objects.get_x("ZONE_3_BUILDING_10532"),
		objects.get_y("ZONE_3_BUILDING_10532"),
		'BUILDING_BUNKER_SPRENGUNG',
		objects.get_direction("ZONE_3_BUILDING_10532"))

	objects.set_active_state("BUILDING_BUNKER_SPRENGUNG",INACTIVE)
	system.mark_for_script_use("ZONE_3_BUILDING_10532")
	system.mark_for_script_use("BUILDING_BUNKER_SPRENGUNG")

	# boxes at weapon storage
#	system.create_object("SET_AMMOPACK_7_65_MM", 518.29, 252.36, "BUNKER_TRESOR_AMMOPACK_1", 0)
#	system.create_object("SET_AMMOPACK_7_65_MM", 518.16, 252.19, "BUNKER_TRESOR_AMMOPACK_2", 150)
#	system.create_object("SET_MICRO_UZI", 517.91, 252.33, "BUNKER_TRESOR_UZI", 80)
#	system.create_object("SET_AMMOPACK_7_65_MM", 518.23, 252.18, "BUNKER_TRESOR_AMMOPACK_3", 230)
	
#	reposition_bunker_tresor_stuff()

def reposition_bunker_tresor_stuff():
	objects.set_position_free("BUNKER_TRESOR_AMMOPACK_1", 518.30, 252.0, 0.70, grid="BUILDING_BUNKER_SPRENGUNG_INTERIOR_GRID")
	objects.set_position_free("BUNKER_TRESOR_AMMOPACK_2", 518.10, 252.0, 0.70, grid="BUILDING_BUNKER_SPRENGUNG_INTERIOR_GRID")
	objects.set_position_free("BUNKER_TRESOR_UZI", 517.80, 252.0, 0.70, grid="BUILDING_BUNKER_SPRENGUNG_INTERIOR_GRID")
	objects.set_position_free("BUNKER_TRESOR_AMMOPACK_3", 518.20, 252.0, 0.16, grid="BUILDING_BUNKER_SPRENGUNG_INTERIOR_GRID")
	#objects.set_position_free("Z3 RATSKULL_DIARY", 518.0, 252.0, 0.16, grid="BUILDING_BUNKER_SPRENGUNG_INTERIOR_GRID")

def anim_windrad(objectid=None):
	objects.play_animation('BUILDING_502','ANIM_WINDRAD',callback=['ONEND',anim_windrad])
	if not hasattr(data(),"windradsound"):
		data().windradsound=True
		sounds.play_3d_sound_object(sfx_id="working_windmill",object='BUILDING_502', loop=True)
	
## check if any zone-dependent quests are active
def checkZoneDependencies():	
	if was_zone_entered("zone_5.zone_5"):
		if data("zone_5.zone_5").Familie_wird_Eskortiert:
			if data().felsenwohungsbesichtigung  == 0:
				data().ian_linda_paula_folgen = True

# init all water ressources
def initWaterResources():
	water.set_water_source(534.0,214.4, 4)
	water.set_water_source(553.5,383.9, 3)
	water.set_water_source(527.5,648.5, 2)
	water.set_water_source(405.9,630.2, 1)

# setzt chars mortal bzw immortal
def init_character_states():
	npcs = system.get_npcs()
	for npc in npcs:
		objects.set_immortal_state(npc, False)
		if npc not in RATSKULLS + RATSKULLS_BUNKER:
#			if not npc in ["DONALD RUMS", "HERMAN", "EINSIEDLER", "GONZO", 'MERCENARY_HENRY']:
			if not npc in ['MERCENARY_HENRY']:
				objects.set_immortal_state(npc, True)
	
	# Bison Leiche
	objects.set_active_state("ZONE_3_BUILDING_685",False)
	objects.destroy("DEAD_BISON")
	data().Obj_BisonKadaver = "DEAD_BISON"
	system.notify_timer(data().Timer_Dead_Bison, data().Timervalue_Dead_Bison)


# initialisiert die questitems, die man durch das killen eines npcs bekommen kann
def init_questitems():
	objects.create_item_in_inventory("DONALD RUMS","SET_C4_REMOTE_CONTROL",data().obj_DonaldsC4)
	objects.set_attribute(object=data().obj_DonaldsC4, attribute="generic_item", value=False)

	objects.create_item_in_inventory("MCKANZEE", "SET_CAR_BATTERY", id=data().obj_Autobatterie)
	objects.set_attribute(object=data().obj_Autobatterie, attribute="generic_item", value=False)
	
def on_map_reentry():
	initFX()
	location = GetZoneEnterLocationVehicles( system.zone_transfer_get_direction() )
	system.zone_transfer_place_vehicles( location[0], location[1] )
	location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
	system.zone_transfer_place_characters( location[0], location[1] )
	init_non_rest_areas()
	checkZoneDependencies()
	schedules.init_schedules()
	init_patch()
	
	# Leiche auffrischen
	if objects.exists("DEAD_BISON") and not data().mq_animal_ausgeweidet["DEAD_BISON"]:
		objects.set_active_state("DEAD_BISON",True)
		
	if objects.exists("BERGTIGERIN") and not data().mq_animal_ausgeweidet["BERGTIGERIN"] and data().BergtigerDead:
		objects.set_active_state("BERGTIGERIN",True)
	
	if objects.exists("BISON") and not data().mq_animal_ausgeweidet["BISON"]:
		objects.set_active_state("BISON",True)
	
	check_ratskulls_dead()
	check_no_gno()
	
def on_post_load():
	initFX()
	checkZoneDependencies()
	schedules.init_schedules()
	init_patch()
	
def on_approach(target, operator):
	if not object_events.on_approach(target, operator):
#		if target == "LUISA":
#			stop_sound_luisa_cry()
		dialogs.on_approach(target, operator)

def on_wait_for_commando(id):
	if id=="GEORG" and data().Georg_LiegtUnterTraktor and not data().Georg_GenugGelegen and not data().Stop_Ratskulls_All:
		character.play_animation(id, "CM_NPC_STEHEN_UNTER_WAGEN_KRIECHEN_LOOP")
		return True

	if id=="RATSKULLS A" and data().BesoffeneRatskullSchlaeft:
		character.play_animation(id, "CM_NPC_LIEGEN_LOOP")
		return True

	if (id in ["MIA","PIA"] and system.get_qb_entry_state(data().QB_012) != COMPLETE):
	   	return schedules.Activity(id)
		
	if ((id == "DOERFLER A" and not data().Doerfeler_TA_gestartet) 
	   or (id == "DOERFLER B" and not data().Doerfeler_TA_gestartet) 
	   or (id == "DOERFLER C" and not data().Doerfeler_TA_gestartet) 
	   or (id == "GONZO" and data().gonzo_killing_spree) 
	   or (id == "GEORG" and not (data().Georg_GenugGelegen 
			and system.get_qb_entry_state(data().QB_004) in [UNCOMPLETE,COMPLETE]) and not data().Stop_Ratskulls_All)):
				return False

	if (id == 'JIMMY'):
		if data().Jimmy_Kartoffeln_Klauen:
			if not data().Jimmy_Klaut:
				character.play_animation(id, 'CM_KNIEND_WASSERLOCH_GRABEN_START')# 'CM_KNIEND_WASSERLOCH_GRABEN_START')
				character.play_animation(id, 'CM_KNIEND_WASSERLOCH_GRABEN_LOOP')# 'CM_KNIEND_WASSERLOCH_GRABEN_LOOP')
				data().Jimmy_Klaut = True
				return True
			if random.choice([1,0,0,0]):
				character.play_animation(id, 'CM_KNIEND_WASSERLOCH_GRABEN_ENDE')# 'CM_KNIEND_WASSERLOCH_GRABEN_ENDE')
				data().Jimmy_Klaut = False
				pos = random.choice(JIMMY_KARTOFFEL_KLAUEN)
				objects.move_to(id, pos[0], pos[1], callback = ['ONEND', Jimmy_Kartoffeln_Klauen_Start])
				return True
			return schedules.Activity(id)
		
		elif data().Jimmy_Tiere_Aergern and system.get_mission_time().get_day_time() >= time("12:30:00") and system.get_mission_time().get_day_time() <= time("16:00:00"):
			if not len(data().Animales):
				return True
			data().Tier = random.choice(data().Animales)
			data().Animales.remove(data().Tier)
			objects.move_to_object('JIMMY', data().Tier, callback = [['ONEND', Lambda('objects.turn_to_object("JIMMY", "%s")' %data().Tier)],
																  ['ONEND', Tier_Aergern]])
			return True
	
	return schedules.Activity(id)

def Tier_Aergern(id):
	character.play_animation(id, 'CM_STEHEN_TASCHENDIEBSTAHL_VORN', callback = ['ONEND', Lambda('Kuh_Haut_Ab("%s")'%data().Tier)])
	sounds.play_3d_sound(sfx_id="cow_1", x=objects.get_x(id), y=objects.get_y(id), z=0)
	
def Kuh_Haut_Ab(id):
	pos = random.choice(TIERE_BAUERNHOF)
	objects.move_to(id, pos[0], pos[1],speed = MT_FAST, callback = ['ONEND', Lambda('data().Animales.append("%s")'%id)])

def Jimmy_Kartoffeln_Klauen_Start(id):
	pos = random.choice(JIMMY_KARTOFFEL_KLAUEN)
	objects.move_to(id, pos[0], pos[1], callback = ['ONEND', Lambda('data().Jimmy_Kartoffeln_Klauen = True')])

def Jimmy_Kartoffeln_Klauen_Ende(id):
	character.play_animation(id, 'CM_KNIEND_WASSERLOCH_GRABEN_ENDE')# 'CM_KNIEND_WASSERLOCH_GRABEN_ENDE')
	data().Jimmy_Kartoffeln_Klauen = False

	
def stop_sound_luisa_cry():
	if objects.has_attribute("LUISA", "playing_sound"):
		objects.set_attribute("LUISA", "playing_sound", None)
		sounds.stop_sound(id="LUISA_CRYING")

def start_sound_luisa_cry():
	if not objects.has_attribute("LUISA", "playing_sound"):
		objects.set_attribute("LUISA", "playing_sound", "LUISA_CRYING")
		sounds.play_3d_sound_object(sfx_id="crying_female",object="LUISA", loop=True, identifier="LUISA_CRYING")
	
def check_luisa_crying():
	if not objects.is_destroyed("LUISA"):
		if ((system.get_qb_entry_state(data().QB_012) in [INACTIVE, UNCOMPLETE]) and 
			(not system.get_qb_entry_state(data().QB_011) == COMPLETE)):
			if get_location("LUISA") != 1 and objects.get_grid("LUISA") == "landscape":
				if sounds.is_sound_playing('LUISA_CRYING'):
					stop_sound_luisa_cry()
				enemy_script.delay(1, Lambda('start_sound_luisa_cry()'))
				system.notify_timer(data().Timer_Luisa_Cry, 20000)
			else:
				stop_sound_luisa_cry()
				system.notify_timer(data().Timer_Luisa_Cry, 20000)
		else:
			stop_sound_luisa_cry()
			system.notify_timer(data().Timer_Luisa_Cry, 20000)
	else:
		stop_sound_luisa_cry()

def on_timer(id):
	#print "#############################timer!"
	#print id
	if id == data().Timer_Luisa_Cry:
		check_luisa_crying()
	
	if id == data().Timer_RatskullASnork:
		if not objects.is_destroyed("RATSKULLS A"):
			if data().BesoffeneRatskullSchlaeft:
				sounds.play_3d_sound_object(sfx_id="snoring_drunken_female",object="RATSKULLS A")
				system.notify_timer(data().Timer_RatskullASnork, random.randint(13000, 19000))
		

	if id == data().Timer_BarbaraAutsch:
		dialogs.onBarabaraKilled()

	if id == data().Timer_DonaldAnsprache:
#		print "#########################donald timer"
		if not data().spieler_von_donald_angesprochen:
			if objects.get_distance("ALTER_EGO", "DONALD RUMS") <= 5.0:
				if objects.is_destroyed("DONALD RUMS"):
					return
				for id in system.get_pcs():
					objects.cancel_commandos(id)
					if id != "ALTER_EGO":
						objects.turn_to_object(id, "DONALD RUMS")
					else:
						objects.turn_to_object(id, "DONALD RUMS", callback=["ONEND",Lambda('dialogs.initDlg_008_Sprengmeister_WillNichtJagen()')])
						data().spieler_von_donald_angesprochen = True
			else:
				system.notify_timer(data().Timer_DonaldAnsprache,data().Timervalue_DonaldAnsprache)
	
	#print "[debug on_timer()",id,"]"
	if id == data().Timer_CutsceneResponder:
		if ((not system.is_cutscene()) and (not dialog.is_dialog_active())):
			system.fade(FADE_OUT)
			data().counter_fade = 1
			system.notify_timer(data().Timer_GonzoScene,data().Timervalue_GonzoScene)
		else:
			system.notify_timer(data().Timer_CutsceneResponder,data().Timervalue_CutsceneResponder)

	if id == data().Timer_GonzoScene:
			if objects.is_destroyed("BARBARA") or objects.is_destroyed("GONZO"):
				end_cutscene(chars=[])
				system.fade(FADE_IN)
				# system.set_qb_entry_state(data().QB_014, IMPOSSIBLE)
			else:
				if data().counter_fade == 1:
					objects.cancel_commandos("GONZO")
					objects.move_to("GONZO", 507.14,708.30, "landscape",MT_SLOW, callback=["ONEND",GonzoKilledSeineFrau])
					data().counter_fade = 0
					system.fade(FADE_IN)
					system.start_cutscene()
					system.set_camera_view(CAMVIEW_GONZOBARBARA_INTRO)#CAMVIEW_GONZO_KILLS_BARBARA_1)
					system.notify_timer(data().Timer_GonzoScene,data().Timervalue_GonzoScene)
	
	if id == data().Timer_GonzoSceneCam:
		if not objects.is_destroyed("GONZO"):
			if objects.is_destroyed("BARBARA"):
				system.fade(FADE_OUT)
				system.notify_timer(data().Timer_GonzoScene,data().Timervalue_GonzoScene)
			else:
				if ((not system.is_cutscene()) and (not dialog.is_dialog_active())):
					system.fade(FADE_OUT)
					data().counter_fade = 1
					system.notify_timer(data().Timer_GonzoScene,data().Timervalue_GonzoScene)
				else:
					objects.cancel_commandos("GONZO")
					system.notify_timer(data().Timer_CutsceneResponder,data().Timervalue_CutsceneResponder)

	if id == data().Timer_DonaldWiederRaus:
		objects.step_to("DONALD RUMS",571.40, 645.77, speed=MT_SLOW)
		allow_activity("DONALD RUMS")

	if id == data().Timer_LukeFolgt:
		if data().luke_folgt:
			#objects.move_to_object("LUKE_Z3","ALTER_EGO")
			if objects.get_distance("ALTER_EGO","LUKE_Z3")>=60.0:
				objects.cancel_commandos("LUKE_Z3")
				dialogs.initDlg_108_LukeWillNichtMehr()
			else:
				if objects.get_distance("LUKE_Z3",data().Obj_KisteLuke) <= 8.0:
					data().luke_an_kiste = True
					data().luke_folgt = False
					prohibit_activity("LUKE_Z3")
					dialogs.initCutscene_110_LukeInspiziertDasSchloss()
				else:
					system.notify_timer(data().Timer_LukeFolgt,data().Timervalue_LukeFolgt)

	elif id==data().Timer_BunkerRedskullsAppear:
		ratskulls_bunker_appear()

	elif id==data().Timer_Zone4Comment:
		if not dialog.is_dialog_active():
			if was_zone_entered("zone_4.zone_4"):
				if  (system.get_qb_entry_state(data("zone_4.zone_4").QB_010 ) in [UNCOMPLETE]):
					dialogs.initDlg_070_Spieler_Zone4Comment()
			else:
				dialogs.initDlg_070_Spieler_Zone4Comment()
		else:
			system.notify_timer(data().Timer_Zone4Comment,data().Timervalue_Zone4Comment)

	elif id==data().Timer_GonzoGelaber:
		system.notify_region_entered(region="GonzosFeld", partyid="UISPIELER")

	elif id==data().Timer_GonzoTimeout:
		if not objects.is_destroyed("GONZO"):
			data().gonzo_killing_spree = True
			#print "jan: gonnzomortal"
			objects.set_immortal_state('GONZO', False)
			#jan: get the weapon, so he does not fight barehandet against the PCs
			character.equip(char="GONZO", equipment="SET_SPECIAL_38", direct_ammo_load=True)
			
			finish_activity("BARBARA")
			finish_activity("GONZO")
			prohibit_activity("BARBARA")
			prohibit_activity("GONZO")
			objects.move_to("BARBARA",507.1,707.68, "landscape",MT_SLOW)
			objects.turn_to_direction("BARBARA",DIR_SOUTH)
			objects.set_attribute( object="GONZO", attribute="foes", value=["UISPIELER"])
			objects.move_to("GONZO", 354.0, 662.44, "landscape", MT_FAST)
			objects.move_to("GONZO", 434.0, 662.44, "landscape", MT_FAST)
			lambda_string = "system.notify_timer(data().Timer_GonzoSceneCam,data().Timervalue_GonzoSceneCamSwitch)"
			objects.move_to("GONZO", 499.0, 691.44, "landscape", MT_FAST, callback=["ONEND",Lambda(lambda_string)])
			objects.move_to("GONZO", 507.14,708.30, "landscape",MT_SLOW)

	elif id==data().Timer_GeorgRepariertTraktor:
		system.notify_region_entered(region="GeorgsTraktor", partyid="UISPIELER")

	elif id==data().Timer_Kuh_Massaker:
		if data().Kuh_Massaker==0:
			objects.move_to(object="KUH1", x=442, y=354, grid="landscape", speed=MT_FAST, callback=["ONEND",onKuh1Explode])
			data().Kuh_Massaker = data().Kuh_Massaker + 1
			system.notify_timer(data().Timer_Kuh_Massaker, data().Timervalue_Kuh_Massaker_2)
		elif data().Kuh_Massaker==1:
			objects.move_to(object="KUH2", x=446, y=352, grid="landscape", speed=MT_FAST, callback=["ONEND",onKuhExplode])
			data().Kuh_Massaker = data().Kuh_Massaker + 1
			system.notify_timer(data().Timer_Kuh_Massaker, data().Timervalue_Kuh_Massaker_3)
		elif data().Kuh_Massaker==2:
			# dont move player char
			# objects.move_to(object="ALTER_EGO", x=450, y=364, grid="landscape")
			data().Kuh_Massaker = data().Kuh_Massaker + 1
			system.notify_timer(data().Timer_Kuh_Massaker, data().Timervalue_Kuh_Massaker_4)
		elif data().Kuh_Massaker==3:
			objects.move_to(object="KUH3", x=442, y=346, grid="landscape", speed=MT_FAST, callback=["ONEND",onKuhExplode])
			data().Kuh_Massaker = data().Kuh_Massaker + 1
			system.notify_timer(data().Timer_Kuh_Massaker, data().Timervalue_Kuh_Massaker_5)
		elif data().Kuh_Massaker==4:
			objects.move_to(object="KUH4", x=446, y=344, grid="landscape", speed=MT_FAST, callback=["ONEND",onKuh4Explode])
			data().Kuh_Massaker = data().Kuh_Massaker + 1
			system.notify_timer(data().Timer_Kuh_Massaker, data().Timervalue_Kuh_Massaker_6)
		elif data().Kuh_Massaker==5:
			objects.move_to(object="KUH5", x=444, y=335, grid="landscape", speed=MT_FAST, callback=["ONEND",onKuh5Survive])
			data().Kuh_Massaker = data().Kuh_Massaker + 1
			system.notify_timer(data().Timer_Kuh_Massaker, data().Timervalue_Kuh_Massaker_7)
		elif data().Kuh_Massaker==6:
			objects.move_to(object="GEORG", x=416.66,y= 365.22, grid="landscape", speed=MT_SLOW)
			data().Kuh_Massaker = data().Kuh_Massaker + 1
			# system.notify_timer(data().Timer_Kuh_Massaker, data().Timervalue_Kuh_Massaker_8)
	
	# wird jetzt für die Steuerung des RATSKULLS WAFFENLAGER D genutzt bei der Kuhanimation
	elif id==data().Timer_ratskull_discuss_dead_cows:
		if objects.is_alive_and_active("RATSKULLS WAFFENLAGER D"):
			objects.move_to("RATSKULLS WAFFENLAGER D",495.32, 262.87) #, callback = ['ONEND', Lambda('objects.turn_to_direction("RATSKULLS WAFFENLAGER D", DIR_WEST)')])
			objects.turn_to_direction("RATSKULLS WAFFENLAGER D", DIR_WEST)
	
	elif (id==data().Timer_SpawnTimeChecker):
		clock = system.get_mission_time().get_day_time()
		system.notify_timer(data().Timer_SpawnTimeChecker,data().Timervalue_SpawnTimeChecker)
		if not data().BergtigerDead:
			starteTimerBergtigerin()
		if (clock >= time("06:00:00") and clock < time("22:00:00")):
			spawnanimals.spawnAnimals(INACTIVE)
		else:
			spawnanimals.spawnAnimals(ACTIVE)

	## Zeitauslöser ... Auftauchen und verschwinden des Bergtigers
	## (triggert alle halbe Stunde zwischen 22:45:00 und 3:15:00) siehe starteTimerBergtigerin()
	## hört auf zu triggern sobald der Bergtiger tot ist
	elif (id==data().Timer_BergTigerChecker):
		if not data().BergtigerDead:
			clock = system.get_mission_time().get_day_time()
			if (clock >= time("22:45:00") or clock < time("3:15:00") and data().D_93_Ende2_gelaufen):
				system.notify_timer(data().Timer_BergTigerChecker,data().Timervalue_BergtigerChecker)
				if (clock >= time("0:00:00") and clock < time("2:00:00")):
					spawnBergtigerin(ACTIVE)
				else:
					spawnBergtigerin(INACTIVE)

	## Georg hat genug gelegen, jetzt geht sein TA los
	elif (id==data().Timer_GeorgGenugGelegen):
		data().Georg_LiegtUnterTraktor = False
		finish_activity("GEORG")
		character.set_approachable_state("GEORG",NOTAPPROACHABLE)
		objects.step_to("GEORG",496.0,227.5,MT_SLOW)
		objects.move_to("GEORG",443.99,339.72, "landscape",MT_SLOW,callback=["ONEND",onGeorgSavesKuh5])
	
	elif (id==data().Timer_GeorgGenugGelegen_no_ratskulls):
		data().Georg_LiegtUnterTraktor = False
		finish_activity("GEORG")
		
		#character.set_approachable_state("GEORG",NOTAPPROACHABLE)
		#objects.step_to("GEORG",496.0,227.5,MT_SLOW)
		#objects.move_to("GEORG",443.99,339.72, "landscape",MT_SLOW,callback=["ONEND",onGeorgSavesKuh5])

	elif (id == data().Timer_Wilma_Rufen):
		dialogs.initCutscene_Dlg_037_Spieler_UntersuchtFelsenwohnung_2()
		
	elif id == data().Timer_Dead_Bison:
		objects.set_position("DEAD_BISON",302.5,328.3)
		objects.set_direction("DEAD_BISON",270)
		

## Georg rettet die 5te Kuh aus dem Minenfeld
def onGeorgSavesKuh5(id):
	objects.turn_to_object("GEORG","KUH5")
	character.play_animation("GEORG","CM_NPC_TIER_FUETTERN_START")
	character.play_animation("GEORG","CM_NPC_TIER_FUETTERN_LOOP")
	character.play_animation("GEORG","CM_NPC_TIER_FUETTERN_ENDE",callback=["ONEND",makeTAActive])

def makeTAActive(id):
	objects.move_to("GEORG",439.5,360.5, "landscape",MT_SLOW)
	objects.move_to("KUH5",439.5,360.5, "landscape",MT_SLOW)
	objects.move_to("KUH5",data().Pos_Kuehe["KUH5"][0],data().Pos_Kuehe["KUH5"][1], "landscape",MT_SLOW)
	data().Georg_GenugGelegen = True
	daily_routine.allow_activity('GEORG')

def MineKaBumm(id):
	x,y,z = objects.get_position(id)
	system.start_effect(startx=x,starty=y,startz=0,dirx=x,diry=y,dirz=0,
						parameter=fx_explosion_medium)
	sounds.play_3d_sound(sfx_id="z3_landmine",x=x,y=y,z=0)
	
def minefield_entered(object_list):
	if not isinstance(object_list, list):
		object_list = [object_list]
	if not len(object_list):
		return
		
	car_id = None
	for character_id in object_list:
		if character.get_vehicle_from_char(character_id):
			car_id = character.get_vehicle_from_char(character_id)
		elif not objects.is_destroyed(character_id):
			objects.destroy(character_id)
			
	if car_id:
		objects.destroy(car_id)
	
	
def on_enter_region(id, objectid, partyid):
	print "[on_enter_region(",id, str(objectid), partyid,"]" #jan
	# non-permanent triggers: objectid is list of all chars in region
	
	if( id in ["MINEFIELD1", "MINEFIELD2","MINEFIELD3","MINEFIELD4",
			"MINEFIELD5","MINEFIELD6","MINEFIELD7","MINEFIELD8",
			"MINEFIELD9","MINEFIELD9a","MINEFIELD9b","MINEFIELD10",
			"MINEFIELD11","MINEFIELD12","MINEFIELD13","MINEFIELD14",
			"MINEFIELD15"]) and not data().Stop_Ratskulls_All:
		if not (id=="MINEFIELD9" and data().MainQuest_IgnoreMines):
			print "minentrigger",objectid
			
			minefield_entered(objectid)
			
			if isinstance(objectid,list):
				if len(objectid): objectid=objectid[0]
				else: return
			#if objects.is_destroyed()
			
			#objects.destroy(objectid)
			pcs = system.get_pcs()
			MineKaBumm(objectid)
			#print ">>> minefield -> pcs", pcs
			for pc in system.get_pcs():
				if not objects.is_destroyed(pc):
					objects.cancel_commandos(pc)
					objects.turn_to_object(pc, objectid)
			if objectid in pcs:
				pass
				#print ">>> minefield -> halt all pcs"
				
			system.notify_region_entered(region=id, partyid="UISPIELER")
			
		elif not data().MainQuest_BarbecueComment:
			data().MainQuest_BarbecueComment = True
			dialogs.initDlg_063_Kuehe_Lecker()
			
		return

	if isinstance(objectid,list):
		if len(objectid): objectid=objectid[0]
		else: return
	
	if id == 'REGION_HUMVEE_Z3':
		if not data().HUMVEE_Z3_Untersucht:
			dialogs.initDlg_133_HUMVEE()
		
	elif id=="MiaAndPiaAtHome":
		if objectid == "MIA":
			data().ZwillingsQuest_MiaAtHome = True
		elif objectid == "PIA":
			data().ZwillingsQuest_PiaAtHome = True
		else:
			assert False
		if data().ZwillingsQuest_MiaAtHome and data().ZwillingsQuest_PiaAtHome:
			data().miapia_folgen = False
			stop_sound_luisa_cry()
			if not system.get_qb_entry_state(data().QB_012) == COMPLETE:
				system.set_qb_entry_state(data().QB_012, COMPLETE)
			
			#if not system.get_qb_entry_state(data().QB_011) == COMPLETE:
			#	system.set_qb_entry_state(data().QB_011, COMPLETE)
			if not system.get_qb_entry_state(data().QB_010) == INACTIVE:
				system.set_qb_entry_state(data().QB_010, INACTIVE)
			#if not system.get_qb_entry_state(data().QB_012) == INACTIVE:
			#	system.set_qb_entry_state(data().QB_012, INACTIVE)
			character.add_experience_party( experience=data().Exp_MiaAndPia )

	elif id=="GonzosFeld":
		if not data().GonzoQuest_Gonzo_Dead and not system.get_qb_entry_state(data().QB_014) == UNCOMPLETE:
			system.notify_timer(data().Timer_GonzoGelaber, random.randint(7, 14) * 1000)
			if not dialog.is_dialog_active():
				if not ((get_location("GONZO") == LOCATION_1) or (get_location("GONZO") == LOCATION_2)):
					dialogs.initDlg_023_Gonzo_AckertAufDemAcker()

	elif id=="GeorgsTraktor":
		if data().Georg_LiegtUnterTraktor:
			if not dialog.is_dialog_active():
				dialogs.initDlg_006_Bauer_TraktorKaputt()
		system.notify_timer(data().Timer_GeorgRepariertTraktor, random.randint(10, 30) * 1000)

	elif id=="SaeuferAmFeuer": # and not data().Stop_Ratskulls_Distillery:
		if not data().DoerflerKilled > 0:
			if data().SchnappsQuest_Ratskulls_Killed < 2:
				if system.get_qb_entry_state(data().QB_006) == INACTIVE:
					dialogs.initCutscene_Dlg_018_Doerfler_WoIstDerSchnapps()
			if data().SchnappsQuest_Ratskulls_Killed >=2:
				data().Doerfeler_TA_gestartet = True

	elif id=="SaeuferRatskulls" and not data().Stop_Ratskulls_Distillery:
		if (not objects.is_destroyed("RATSKULLS A") and not objects.is_fighting("RATSKULLS A") and
		not objects.is_destroyed("RATSKULLS B") and not objects.is_fighting("RATSKULLS B") and
		not objects.is_destroyed("RATSKULLS C") and not objects.is_fighting("RATSKULLS C") and
		not data().ratskulls_schlafen):
			for id in ["RATSKULLS A","RATSKULLS B","RATSKULLS C"]:
				objects.cancel_commandos(id)
				prohibit_activity(id)
				character.set_approachable_state(id,APPROACHABLE)
			dialogs.initCutscene_034_Ratskulls_WhiskyMachtSpass()

	elif id=="BunkerKommentar":
#		if data().Ratskulls_Waffenlager < 4:
#			system.notify_region_entered(region="BunkerKommentar", partyid="UISPIELER")
#		else:
		if not data().Stop_Ratskulls_All:
			character.set_approachable_state("GEORG",APPROACHABLE)
			objects.add_closed_lock("ZONE_3_BUILDING_10532", "lock1", closure_type='normal') #close the bunker
			dialogs.initCutscene_004_Spieler_BunkerUntersuchen()
		else:
			dialogs.initCutscene_Dlg_064_Spieler_Waffenlager()
			#set george at entrance and go to traktor
			

	elif id=="Waffenlager":
		dialogs.initCutscene_Dlg_064_Spieler_Waffenlager()
		#vielleicht umleiten auf neuen Pete Dialog?

	elif id=="Waffenlager2":
		#print "waffenlager rein"
		onRatskullsAlarmOthers("RATSKULLS WAFFENLAGER D") #jan: alarm wenn region betreten

	elif (id in ["Steinbruch1", "Steinbruch2"]) and not data().Stop_Ratskulls_All:
#		print "####################Steinbruch "
		if (not data().donald_schlaeft and
			not system.get_qb_entry_state(data().QB_005) in [COMPLETE] and
			not objects.is_destroyed("DONALD RUMS") and 
			not data().spieler_von_donald_angesprochen):
#				print "####################Rums Notify "
				system.notify_timer(data().Timer_DonaldAnsprache, data().Timervalue_DonaldAnsprache)

	elif id=="MINEFIELD FIRST WARNING" and not data().Stop_Ratskulls_All:
		if not system.get_qb_entry_state(data().QB_002) in [UNCOMPLETE, COMPLETE]:
			if not data().pete_intro:
				data().pete_intro = True
				objects.cancel_commandos('GEORG')
				objects.turn_to_object("GEORG","ALTER_EGO", callback=["ONEND", onGeorgSightedPlayer])
				data().Second_Mine_Warning = False
	
	elif id=="MINEFIELD SECOND WARNING" and not data().Stop_Ratskulls_All:
		if not data().MainQuest_IgnoreMines:
			if (not system.get_qb_entry_state(data().QB_003) == COMPLETE) and not data().Second_Mine_Warning:
				if system.get_qb_entry_state(data().QB_002) == INACTIVE:
					objects.cancel_commandos(objectid)
					data().Second_Mine_Warning = True
					dialogs.initDlg_072_Warnung_Minenguertel()
				else:
					objects.cancel_commandos(objectid)
					dialogs.initDlg_033_Spieler_KeinBockAufMinen()
					data().Second_Mine_Warning = True
		else:
			if data().luke_folgt and not data().Second_Mine_Warning:
				dialogs.initDlg_109_SpielerWarntLuke()
				data().Second_Mine_Warning = True

			elif objects.is_destroyed("LUKE_Z3"):
				if not data().luke_leiche_gesehen:
					data().luke_leiche_gesehen = True
					dialogs.initDlg_116_LukeIstExplodiert()

	#elif( id in ["MINEFIELD1", "MINEFIELD2","MINEFIELD3","MINEFIELD4",
	#		"MINEFIELD5","MINEFIELD6","MINEFIELD7","MINEFIELD8",
	#		"MINEFIELD9","MINEFIELD9a","MINEFIELD9b","MINEFIELD10",
	#		"MINEFIELD11","MINEFIELD12","MINEFIELD13","MINEFIELD14",
	#		"MINEFIELD15"]) and not data().Stop_Ratskulls_All:
	#	if not (id=="MINEFIELD9" and data().MainQuest_IgnoreMines):
	#		#print "minentrigger",objectid
	#		pcs = system.get_pcs()
	#		#print ">>> minefield -> pcs", pcs
	#		MineKaBumm(objectid)
	#		objects.destroy(objectid)
	#		for pc in system.get_pcs():
	#			if not objects.is_destroyed(pc):
	#				objects.cancel_commandos(pc)
	#				objects.turn_to_object(pc, objectid)
	#		if objectid in pcs:
	#			pass
	#			#print ">>> minefield -> halt all pcs"
	#			
	#
	#		system.notify_region_entered(region=id, partyid="UISPIELER")
	#	elif not data().MainQuest_BarbecueComment:
	#		data().MainQuest_BarbecueComment = True
	#		dialogs.initDlg_063_Kuehe_Lecker()

	elif id=="MINEFIELD PATH ENTRY" and data().MainQuest_IgnoreMines and \
		not data().MainQuest_BewareMinesDialog and not data().Stop_Ratskulls_All:
		data().MainQuest_BewareMinesDialog = True
		dialogs.initDlg_080_beware_mines()

	elif id=="Bergtigerin":
		if not data().player_knows_Bergtiger_Huegel:
			data().player_knows_Bergtiger_Huegel = True
#			system.add_minimap_marker(220.22,594.22,"MM_007")#Bergtigerin#
		if data().WaldemarHatGesagtWoDerTigerIst:
			if not data().BergtigerZoneGefunden:
				dialogs.initDlg_096_SpielerFindetBergtigerZone()
				data().BergtigerZoneGefunden = True
			else:
				if data().BergtigerAktiv:
					dialogs.initDlg_097_SpielerFindetBergtiger()
				else:
					clock = system.get_mission_time().get_day_time()
					if (clock >= time("2:00:00") and clock < time("3:00:00")):
						dialogs.initDlg_098_BergtigerHautAb()

	if (id=="Steinbruch1" or id=="Steinbruch2"):
		if not data().player_knows_Steinbruch:
			data().player_knows_Steinbruch = True
			system.add_minimap_marker(561,649,"MM_004")#Quarry

	if id==data().Region_Destillerie:
		if not data().player_knows_Destillerie:
			data().player_knows_Destillerie = True
			system.add_minimap_marker(555.43,400.53,"MM_008")# Destillerie Marker

def onGeorgSightedPlayer(char_id):
	dialogs.initDlg_001_Bauer_Warnung()

def GonzoKilledSeineFrau(id):
	if objects.is_destroyed("GONZO"):
		return
	#system.set_camera_view(CAMVIEW_GONZO_KILLS_BARBARA)
	objects.step_to("GONZO", 507.14,708.30,MT_SLOW)
	objects.turn_to_object("GONZO","BARBARA")
	if data().gonzo_killing_spree:
		dialogs.initCutscene_050_Gonzo_MurkstSeineAlte()

# *KABUMM* eine der kühe ist auf ne mine getrampelt
def onKuhExplode(id):
	MineKaBumm(id)
	objects.set_immortal_state(id,False)
	objects.destroy(id)

def onKuh1Explode(id):
	onKuhExplode(id)
	# peasant complains about dead cows
	dialogs.initDlg_061_Kuehe_Muh(id)
	dialogs.initDlg_003_Bauer_ArmeKuehe()
	#system.set_qb_entry_state(data().QB_002,COMPLETE)
	#system.set_qb_entry_state(data().QB_003,UNCOMPLETE)
	character.set_approachable_state("GEORG",NOTAPPROACHABLE)
	character.add_experience_party(data().Exp_Minenfeld)

def onKuh4Explode(id):
	onKuhExplode(id)
	data().MainQuest_IgnoreMines = True # path through mine field free
	system.notify_region_entered(region="Waffenlager2", partyid="UISPIELER")
	ratskull_hears_exploding_cow()

# die letzte kuh wundert sich
def onKuh5Survive(id):
	dialogs.initDlg_062_Kuehe_Muh(id)
	if not data().MainQuest_Dialog62:
		data().MainQuest_Dialog62 = True
		objects.move_to(object="KUH5", x=444, y=336, grid="landscape", callback=["ONEND", dialogs.onKuhMoveMuh])

# callback fuer das zerstoeren/ toeten von objekten / npcs
def on_object_killed(victim, attacker, weapon_type, weapon_id, victims_party):
	object_events.on_object_killed(victim, attacker, weapon_type, weapon_id, victims_party)
	if victim == "DONALD RUMS":
		if system.get_qb_entry_state(data().QB_005) == INACTIVE:
			system.set_qb_entry_state(data().QB_019, IMPOSSIBLE)
			system.set_qb_entry_state(data().QB_020, IMPOSSIBLE)
			system.set_qb_entry_state(data().QB_021, IMPOSSIBLE)
			system.set_qb_entry_state(data().QB_022, IMPOSSIBLE)
			system.set_qb_entry_state(data().QB_023, IMPOSSIBLE)
			system.set_qb_entry_state(data().QB_005, IMPOSSIBLE)
	
	if victim == "EINSIEDLER":
		if system.get_qb_entry_state(data().QB_008) == UNCOMPLETE:
			system.set_qb_entry_state(data().QB_008, IMPOSSIBLE)

	if victim == "HERMAN":
		pass
	
	if victim in ["MIA","PIA"]:
		if system.get_qb_entry_state(data().QB_011) == UNCOMPLETE:
			system.set_qb_entry_state(data().QB_011, IMPOSSIBLE)
		if system.get_qb_entry_state(data().QB_012) == UNCOMPLETE:
			system.set_qb_entry_state(data().QB_012, IMPOSSIBLE)

	if victim=="BARBARA":
		if system.get_qb_entry_state(data().QB_013) == UNCOMPLETE:
			system.set_qb_entry_state(data().QB_013, IMPOSSIBLE)
		if system.get_qb_entry_state(data().QB_014) == UNCOMPLETE:
			system.set_qb_entry_state(data().QB_014, IMPOSSIBLE)

	if victim=="GONZO" and not system.get_qb_entry_state(data().QB_014) == IMPOSSIBLE:
		dialogs.initDlg_026_Gonzo_RestInPieces()
		system.set_qb_entry_state(data().QB_014, COMPLETE)
		if system.get_qb_entry_state(data().QB_013) == UNCOMPLETE:
			system.set_qb_entry_state(data().QB_013, INACTIVE)
		data().GonzoQuest_Gonzo_Dead = True

	if (victim=="GONZO" and (system.get_qb_entry_state(data().QB_013) == INACTIVE)
		and (system.get_qb_entry_state(data().QB_014) == INACTIVE)):
		data().GonzoQuest_Gonzo_Dead = True
		data().gonzo_dead_ohne_auftrag = True

	if victim in ["RATSKULLS A","RATSKULLS B","RATSKULLS C"]:
		data().SchnappsQuest_Ratskulls_Killed = data().SchnappsQuest_Ratskulls_Killed + 1
		if data().SchnappsQuest_Ratskulls_Killed >2:
			data().Doerfeler_TA_gestartet = True
			system.set_qb_entry_state(data().QB_006,INACTIVE )
			system.set_qb_entry_state(data().QB_007,INACTIVE )
			system.set_qb_entry_state(data().QB_018,UNCOMPLETE)


	if(	victim in ["RATSKULLS WAFFENLAGER A","RATSKULLS WAFFENLAGER B","RATSKULLS WAFFENLAGER C","RATSKULLS WAFFENLAGER D"]):
		data().Ratskulls_Waffenlager = data().Ratskulls_Waffenlager + 1
		if data().Ratskulls_Waffenlager >= 4:
			#system.set_qb_entry_state(data().QB_003, COMPLETE)
			character.add_experience_party(data().Exp_Waffenlager_Aussen)
		if hasattr(data(),"DeadCowsDontTalk") and data().DeadCowsDontTalk:
			data().DeadCowsDontTalk = False
			dialog.jump_to("ENDDIALOG","DeadCowsDontTalk")

	if(	victim in ["RATSKULL_LEADER","RATSKULLS BUNKER A","RATSKULLS BUNKER B","RATSKULLS BUNKER C","RATSKULLS BUNKER D"]):
		data().Ratskulls_Bunker = data().Ratskulls_Bunker + 1
		if data().Ratskulls_Bunker >= 5:
			#system.set_qb_entry_state(data().QB_004, COMPLETE)
			character.add_experience_party(data().Exp_Ratskulls_Bunker)
			system.notify_timer(timer=data().Timer_Zone4Comment, delay=data().Timervalue_Zone4Comment)

	if victim in data().Obj_Kuehe:
		randomBloodShed(victim)

	if victim in data().DoerflerDistilleryQuest:
		data().DoerflerKilled +=1
		if data().DoerflerKilled == 3:
			deactivateDestilleryQuest()

	if victim=="BERGTIGERIN":
		data().BergtigerDead = True
		if data().VonDonaldAufgabeBesorgeFleisch:
			dialogs.initDlg_099_BergtigerGekillt()
		else:
			dialogs.initDlg_130_SpielerHatBergtigerinErledigtOhneAuftrag()
	
	if victim == "BISON":
		data().BisonDead = True
		data().one_dead_bison_found = True
		if system.get_qb_entry_state(data().QB_022) == UNCOMPLETE:
			system.set_qb_entry_state(data().QB_022,INACTIVE)
			system.set_qb_entry_state(data().QB_023,UNCOMPLETE)
			
	if victim == "LUKE_Z3":
		objects.create_item_in_inventory("LUKE_Z3", "SET_SUPERLW");

def deactivateDestilleryQuest():
	pass

def randomBloodShed(id):
	meat = ["SET_MEAT_RAW_TINY","SET_MEAT_RAW_SMALL","SET_MEAT_RAW","SET_MEAT_RAW_BIG","SET_MEAT_RAW_HUMONGOUS"]
	menge = random.randint(0,10)
	for dummy in range(menge):
		meattype = random.randint(0,len(meat)-1)
		x=objects.get_x(id)
		y=objects.get_y(id)
		direction = random.randint(0,359)
		distance = random.randint(0,2)
		mode = random.randint(0,8)
		if mode == 0:
			system.create_object(equipmenttype=meat[meattype],x=x+distance,y=y-distance,direction=direction)
		elif mode == 1:
			system.create_object(equipmenttype=meat[meattype],x=x-distance,y=y-distance,direction=direction)
		elif mode == 2:
			system.create_object(equipmenttype=meat[meattype],x=x+distance,y=y+distance,direction=direction)
		elif mode == 3:
			system.create_object(equipmenttype=meat[meattype],x=x-distance,y=y+distance,direction=direction)
		elif mode == 4:
			system.create_object(equipmenttype=meat[meattype],x=x,y=y+distance,direction=direction)
		elif mode == 5:
			system.create_object(equipmenttype=meat[meattype],x=x,y=y-distance,direction=direction)
		elif mode == 6:
			system.create_object(equipmenttype=meat[meattype],x=x-distance,y=y,direction=direction)
		elif mode == 7:
			system.create_object(equipmenttype=meat[meattype],x=x+distance,y=y,direction=direction)
		else:
			system.create_object(equipmenttype=meat[meattype],x=x-distance*2.0,y=y-distance*2.0,direction=direction)


def char_openes_bunker_tresure(char, blast=False):
	# da on_blast_lock nicht sinnvoll aufgerufen wird den Marker neu setzen
	if hasattr(data("pick_lock"), "blast_lock") and data("pick_lock").blast_lock:
		blast = True
	if char == "ALTER_EGO":
		if not data().schloss_geknackt:
			#if data().luke_folgt or data().luke_an_kiste:
				#return False
			if can_open_lock(char,blast):
				if not dialog.is_dialog_active():
					system.set_qb_entry_state(data().QB_015,COMPLETE)
					if system.get_qb_entry_state(data().QB_016) != INACTIVE:
						system.set_qb_entry_state(data().QB_016,INACTIVE)
					if data().luke_folgt or data().luke_an_kiste:
						on_crack_lock_luke()
					system.start_cutscene()
					system.set_camera_view([516.42095947265625, 247.34490966796875, 10.855134010314941, 0.26649978756904602, 0.57060486078262329, -0.77678048610687256])
					dialogs.initDlg_103_SpielerWillKistenschlossOeffnen(char, with_crack=True)

				return True
			else:
				if not dialog.is_dialog_active():
					dialogs.initDlg_102_SpielerVerzweifeltAnKistenschloss(char)
				return True
	else:
		if not data().schloss_geknackt:
			if can_open_lock_helper(char,blast):
				system.start_cutscene()
				# Quests und Luke aufraeumen
				system.set_qb_entry_state(data().QB_015,COMPLETE)
				if system.get_qb_entry_state(data().QB_016) != INACTIVE:
					system.set_qb_entry_state(data().QB_016,INACTIVE)
				if data().luke_folgt or data().luke_an_kiste:
					on_crack_lock_luke()
				
				system.set_camera_view(CAMVIEW_BUNKER_TRESOR)
				#char = data().spieler_am_schloss
				objects.move_to(char,518, 251,data().Chest_Cutscene_Grid,speed=MT_FAST)
				#objects.move_to(char,518.06, 249.5,"BUILDING_BUNKER_SPRENGUNG_INTERIOR_GRID",speed=MT_SLOW)
				#objects.step_to(char,518.06, 250.6,speed=MT_SLOW)
				objects.turn_to_direction(char,DIR_SOUTH)
				objects.move_to('ALTER_EGO',519, 250,data().Chest_Cutscene_Grid, speed=MT_FAST, callback = Lambda("objects.turn_to_object('ALTER_EGO','BUILDING_15469')"))
				
				object_events.pre_crack_lock(char)
				#lambda_string = "on_char_opended_lock(%s, %s, %s, %s)"%()
				character.play_animation(char,"STEHEND_TUERSCHLOSS_KNACKEN",callback=["ONEND",on_char_opended_lock])	
				return True
			else:
				if not dialog.is_dialog_active():
					dialogs.initDlg_102_SpielerVerzweifeltAnKistenschloss(char)
				return True
	return None

#*** crack lock callbacks
def can_crack_lock( character_id, object_id, dummy ):	
	if object_id.endswith(data().Obj_KisteLuke):
		return True
		
		#if can_open_lock(character_id, False):
		#	return True
		#else:
		#	if not dialog.is_dialog_active() and not can_open_lock(character_id, True):
		#		if not data().schloss_knacken_1_fehlgeschlagen:
		#			dialogs.initDlg_102_SpielerVerzweifeltAnKistenschloss(character_id)
		#	return False
	#print "global.can_crack_lock"
	return object_events.can_crack_lock( character_id, object_id, dummy )

"""
#wird wohl nicht uebergeben :(
def pre_crack_lock( character_id ):
	objects.cancel_commandos(character_id)
	objects.step_to(character_id,518.06, 250.6,speed=MT_SLOW)
	#print "pre_crack"
	object_event.pre_crack_lock( character_id )
"""

def on_crack_lock( character_id, object_id, dummy_name, x, y, z ):
	
	if object_id.endswith(data().Obj_KisteLuke):
		print "selberknacken"
		#system.set_qb_entry_state(data().QB_015,COMPLETE)
		#system.set_qb_entry_state(data().QB_016,INACTIVE)
		return char_openes_bunker_tresure(character_id,False)

	return object_events.on_crack_lock( character_id, object_id, dummy_name, x, y, z )
	
def on_crack_lock_luke():
	data().luke_folgt = False
	data().luke_an_kiste = False
	data().schloss_geknackt = True
	# Minen fuer Luke scharf machen :)
	for mf in ["MINEFIELD1","MINEFIELD2","MINEFIELD3","MINEFIELD4",
	"MINEFIELD5", "MINEFIELD6","MINEFIELD7","MINEFIELD8",
	"MINEFIELD9","MINEFIELD9a","MINEFIELD9b","MINEFIELD10",
	"MINEFIELD11","MINEFIELD12","MINEFIELD13","MINEFIELD14",
	"MINEFIELD15"]:
		system.notify_region_entered(region=mf, objectid = "LUKE_Z3")

	objects.set_immortal_state("LUKE_Z3", False)
	objects.cancel_commandos("LUKE_Z3")
	dialogs.RoutedMoveTo("LUKE_Z3",ROUTE_LUKE_BACK,speed=MT_FAST)
	objects.turn_to_direction("LUKE_Z3",DIR_NORTH, callback=["ONEND",Lambda('data().luke_wieder_zuhause = True; allow_activity("LUKE_Z3")')])
	
#*** blast callbacks
def can_blast_lock( character_id, object_id, dummy ):
	if object_id.endswith(data().Obj_KisteLuke):
		#return True
		if can_open_lock(character_id, True):
			data().can_blast_lock = True
			return True
		#else:
		#	if not dialog.is_dialog_active() and not can_open_lock(character_id, False):
		#		if not data().schloss_knacken_1_fehlgeschlagen:
		#			dialogs.initDlg_102_SpielerVerzweifeltAnKistenschloss(character_id)
		#	data().can_blast_lock = False
		#	return False
	return object_events.can_blast_lock( character_id, object_id, dummy )
"""
def on_blast_lock( character_id, object_id, dummy_name, x, y, z ):
	if object_id.endswith(data().Obj_KisteLuke):
		if char_openes_bunker_tresure(character_id, True):
			x,y,z = objects.get_full_dummy_position(object_id, dummy_name)
			z = z - objects.get_attribute(interior_object_id,"z") # absolutes z umrechnen auf relatives
			lambda_string = 'object_events.on_lock_explode(object_id="%s",dummy_name="%s",x=%i,y=%i,z=%i)' %(object_id, dummy_name, x,y,z)
			#enemy_script.delay(2.5, Lambda(lambda_string))
			data().on_blast_lock_lambda_string = lambda_string
			return True
		return False
	return object_events.on_blast_lock( character_id, object_id, dummy_name, x, y, z )
"""
#*** use callbacks
def can_use( character_id, object_id ):
	if object_id == "Z3 RATSKULL_DIARY":
#		if objects.count_in_inventory(character_id,object_id)
		return True
	return object_events.can_use( character_id, object_id )

def on_use( character_id, object_id, item_id, item_type ):
	#print "on_use" 
	#print character_id
	#print object_id
	#print item_id
	if item_id == "Z3 RATSKULL_DIARY" and not hasattr(data('zone_3.zone_3'), 'reading_ratskull_diary'): 
		if character_id == 'ALTER_EGO':
			data('zone_3.zone_3').reading_ratskull_diary = True
			dialogs.initDlg_132_SpielerLiestRatskulltagebuch()
			return True
		else:
			dialogs.MercenaryDenyTalk(character_id, "default")
			return True
	return object_events.on_use( character_id, object_id, item_id, item_type )
	
def on_steal(target, operator):
	"""is called when a player char tries to steal something
	
operator - id of the thief
target   - id of the victim
"""	
	inventorylist = objects.get_inventory_list(target)
	pick_pocket = objects.get_attribute(operator, "pick_pocket")

	# Check for talent inside_pocket
	if target=="HERMAN":
		if pick_pocket >79:
			if has_talent( operator, "pick_pocket", "inside_pocket" ):
				# if target ha snot yet an inside_pocket_item, then create one
				if not objects.has_attribute( target, "inside_pocket_item" ):
					inside_pocket_item_type = object_events.get_random_item()
					inside_pocket_item_id = objects.create_item_in_inventory( target, inside_pocket_item_type )
					objects.set_attribute( target, "inside_pocket_item", inside_pocket_item_id )
	
			if inventorylist:
				# show the item panel but filter out the equiped items
				system.item_panel( operator, target, object_events.separate_out_callback )
		else: # heist was a failure
			# target will abuse operator
			lambda_string = 'object_events.heist_failure( target="%s", operator="%s" )' %( target, operator )
			objects.turn_to_object( target, operator, callback=[ "ONEND", Lambda( lambda_string ) ] )
	else:
		return object_events.on_steal(target, operator)
def can_examine_object( character_id, object_id ):
	
	## bisonkadaver
	if object_id.endswith(data().Obj_BisonKadaver):
		if not data().bison_inspected:
			if character_id == "ALTER_EGO":
				return True
	
	if object_id.endswith(data().Obj_KisteLuke):
		if not data().schloss_geknackt:
			return True
		return False
	
	if object_id=="RATSKULLS A":
		if data().BesoffeneRatskullSchlaeft:
			return True
	
	for substring in ["BUILDING_15741"]:
		if object_id.endswith(substring) and character_id == "ALTER_EGO":
			return True
	
	if object_id in ["DEAD_SHADOW"]:
		return True
	
	if object_id in ["BARBARA"]:
		if objects.is_destroyed("BARBARA"):
			return True
	
	if object_id == data().obj_HermansPicklock:
		if (not data().spieler_hat_dietrich and data().luke_dietrich_gesucht):
			return True
	
	if object_id == 'ZONE_3_BUILDING_2747':
		if (data().car_battery_given or data().d_032_restart_c_001):
			return True
	
	if object_id in ['HUMVEE_Z3','ZONE_3_BUILDING_15331']:
		if not data().HUMVEE_Z3_Untersucht:
			return True
	
	if object_id in ['ZONE_3_BUILDING_15743', 'ZONE_3_BUILDING_1420', 'ZONE_3_BUILDING_1421']:
		return True
	
	return object_events.can_examine_object( character_id, object_id )
	

def pre_examine_object( character_id, object_id ):
	if object_id.endswith("BUILDING_15741"):
		objects.set_attribute(object_id, "on_examine_coordinates", [572.5,647.5,0])
		"""
		if not dialog.is_dialog_active():
			dialogs.initCutscene_Dlg_037_Spieler_UntersuchtFelsenwohnung(CAMVIEW_FELSWOHNUNG_1)
			return True
		"""
	object_events.pre_examine_object( character_id, object_id )
	#return False
	
def on_examine_object( character_id, object_id ):
	#print "on_examine_object()",character_id,object_id
	if object_id == data().Obj_KisteLuke:
		if object_events.is_locked_object( object_id ):
			if can_open_lock(character_id, False) or can_open_lock(character_id, True):
				data().Chest_Dialog_Played = True
				dialogs.initDlg_103_SpielerWillKistenschlossOeffnen(character_id, with_crack=False)
			else:
				dialogs.initDlg_102_SpielerVerzweifeltAnKistenschloss(character_id)
			return True
		
	if object_id == data().obj_HermansPicklock:
		if not data().spieler_hat_dietrich:
			dialogs.initDlg_121_SpielerUntersuchtDietrich()
	
	## bisonkadaver
	if (object_id == data().Obj_BisonKadaver):
		if character_id == "ALTER_EGO":
			if not data().bison_inspected:
				dialogs.initCutscene_Dlg_011_Spieler_UntersuchtBison()
				data().bison_inspected = True
			else:
				comments.comment(character_id, "EXAMINE_CADAVER_%i" %(random.randint(1,5)))
			return True

	if object_id=="RATSKULLS A" and data().BesoffeneRatskullSchlaeft:
		if not objects.is_destroyed("RATSKULLS A"):
			dialogs.initDlg_036_Ratskulls_BewusstloseFrau()
		else:
			object_events.on_examine_object( character_id, object_id )
			return True
	"""
	for substring in ["BUILDING_1564","BUILDING_1558"]:
		if object_id.endswith(substring):
			if not dialog.is_dialog_active():
				dialogs.initCutscene_Dlg_037_Spieler_UntersuchtFelsenwohnung(CAMVIEW_FELSWOHNUNG_2)
	"""
	
	#for substring in ["BUILDING_1420","BUILDING_1421"]:
	if object_id.endswith("BUILDING_15741") and character_id == "ALTER_EGO":
		if not dialog.is_dialog_active():
			dialogs.initCutscene_Dlg_037_Spieler_UntersuchtFelsenwohnung(CAMVIEW_FELSWOHNUNG_1)
		return True
	
	if object_id == "DEAD_SHADOW":
		if not data().Spieler_kennt_Schatten:
			dialogs.initDlg_090_UntersucheLeiche()
		else:
			dialogs.initDlg_091_UntersucheLeiche_SpielerKenntSchatten()

	if object_id == "BARBARA":
		if objects.is_destroyed(object_id):
			dialogs.initDlg_051_GonzosFrau_Leiche()
	
	if object_id == 'ZONE_3_BUILDING_2747':
		inventorylist = objects.get_inventory_list(object_id)
		if inventorylist:
			system.item_panel( character_id, object_id )
	
	if object_id in ['ZONE_3_BUILDING_15743', 'ZONE_3_BUILDING_1420', 'ZONE_3_BUILDING_1421']:
		text = random.choice(['D_037_T_002', 'D_037_T_001', 'D_037_T_002'])
		dialog.init_dialog(type=DIALOGSMALL)
		dialog.add_text( text=text, speaker=character_id, follower='ENDDIALOG')
		dialog.start()
		return
	
	object_events.on_examine_object( character_id, object_id )
	return False
		
def on_char_opended_lock(char_id):
	#objects.step_away(char_id)
	if hasattr(data("pick_lock"), "blast_lock") and data("pick_lock").blast_lock:
		print "Setting Explosion"
		objects.remove_item_from_inventory(char_id, "SET_GUN_POWDER")
		
		interior_object_id = None
		#jan: dummy für schloss sind am interior!! 
		if objects.has_attribute(data().Obj_KisteLuke, "attached_interior_objects" ): #jan: hier muss eigentlich über alle interiors itteriert werden, aber wir nutzen momentan nur 1 interior
			interior_object_id = objects.get_attribute(data().Obj_KisteLuke, "attached_interior_objects" )[0]
		else:
			interior_object_id = data().Obj_KisteLuke
		
		dummy_name = "dmyp_lock"
		x,y,z = objects.get_full_dummy_position(interior_object_id, dummy_name)
		#z = z - objects.get_attribute(interior_object_id,"z") # absolutes z umrechnen auf relatives
		system.start_effect( x, y, z, x, y, z, global_defines.fx_explosion )
		sounds.play_3d_sound( "grenade_explo_fire", x, y, z )

	object_events.unequip_and_equip_marked(char_id, "picklock_item" )
	
	if objects.get_distance(char_id, "ALTER_EGO") <= 20.0:
		dialogs.initDlg_104_SpieleKnacktKistenschloss("ALTER_EGO", no_end=True)
	data().spieler_am_schloss = ""
	data().schloss_geknackt = True
	objects.remove_closed_lock_by_name(data().Obj_KisteLuke, "lock1")
	if system.is_cutscene():
		system.end_cutscene()

### gut helper
def check_can_gut(char, obj):
	knifes = ['SET_BIG_KNIFE', 'SET_KNIFE']
	#print "check_can_gut"
	#print char
	#print objects.get_attribute(char, "survival")
	for knife in knifes:
		if objects.count_in_inventory(char, knife):
			if objects.has_attribute(char, "survival"):
				if objects.get_attribute(char, "survival") >= 40:
					if (obj != data().Obj_BisonKadaver):
						if objects.is_destroyed(obj):
							return True
					else:
						return data().bison_inspected
	return False

## returns true if the object can be gutted
# character_id - id of the character
# object_id - id of the object
def can_gut_object( character_id, object_id ):
	if (object_id == "DEAD_BISON" or
		object_id == "BISON" or
		object_id == "BERGTIGERIN"):
		return check_can_gut(character_id, object_id)
	#print "basisfunktion:"
	return object_events.can_gut_object( character_id, object_id )

## called if an item is gutted by a character
# character_id - id of the character
# object_id - id of the object
def on_gut_object( character_id, object_id ):
	if (object_id == "DEAD_BISON" or
		object_id == "BISON" or
		object_id == "BERGTIGERIN"):
		#print 'hallo', check_can_gut(character_id, object_id)
		if check_can_gut(character_id, object_id):
			if not data().mq_animal_ausgeweidet[object_id]:
				data().mq_animal_ausgeweidet[object_id] = True
				new_id = ""
				if object_id=="BISON":
					if not data().obj_BisonfleischKill in objects.get_inventory_id_list('BISON'):
						new_id = data().obj_BisonfleischKill
						objects.create_item_in_inventory(object=object_id, equipment="SET_BISON_MEAT", id=new_id)
				elif object_id  == "BERGTIGERIN":
					if not data().obj_Tigerfleisch in objects.get_inventory_id_list('BERGTIGERIN'):
						new_id = data().obj_Tigerfleisch
						objects.create_item_in_inventory(object=object_id, equipment="SET_TIGER_MEAT", id=new_id)
				else: ## Bisonkadaver
					if not data().obj_BisonfleischKadaber in objects.get_inventory_id_list('DEAD_BISON'):
						new_id = data().obj_BisonfleischKadaber
						objects.create_item_in_inventory(object=object_id, equipment="SET_BISON_MEAT", id=new_id)
				objects.set_attribute(object=new_id, attribute="generic_item", value=False)
		
			if object_id == "DEAD_BISON":
				on_gut_object_bison_2(character_id)
				
			else:
				inventorylist = objects.get_inventory_list(object_id)
				if inventorylist:
					system.item_panel( character_id, object_id )
			return True
		else:
			return False
	return object_events.on_gut_object( character_id, object_id )

	
def on_gut_object_bison_1():
	objects.set_active_state("DEAD_BISON",False)
	objects.set_active_state("ZONE_3_BUILDING_685",True)
	data().Obj_BisonKadaver = "ZONE_3_BUILDING_685"
	system.fade(FADE_IN,callback = Lambda("system.end_cutscene()"))
	
def on_gut_object_bison_2(character_id):
	inventorylist = objects.get_inventory_list("DEAD_BISON")
	if inventorylist:
		system.item_panel( character_id, "DEAD_BISON", callback_close = on_gut_object_bison_3 , callback_cancel = on_gut_object_bison_3)
	else:
		on_gut_object_bison_3(None, None)
	
def on_gut_object_bison_3(id_1, id_2):
	if not "Z3 BISON_MEAT_KADABER" in objects.get_inventory_id_list('DEAD_BISON'):
		system.start_cutscene()
		system.fade(FADE_OUT,callback = Lambda("on_gut_object_bison_1()"))
		
	
## Equipment for NPCs and TA-NPCs
def initEquipment():
	#objects.create_item_in_inventory("EINSIEDLER",    [""])
	objects.create_item_in_inventory("MIA",           ["SET_NORMAL_CLOTHES_4"])
	objects.create_item_in_inventory("PIA",           ["SET_LOW_SHOES","SET_TEDDY_BEAR"])
	objects.create_item_in_inventory("DOERFLER A",    ["SET_NORMAL_CLOTHES_3"])
	objects.create_item_in_inventory("DOERFLER B",    ["SET_TOOTHBRUSH"])
	objects.create_item_in_inventory("DOERFLER C",    ["SET_NORMAL_CLOTHES_5"])
	#objects.create_item_in_inventory("DORFAELTESTER", [""])
	objects.create_item_in_inventory("GONZO",         ["SET_SPECIAL_38", "SET_AMMOPACK_38"])
	objects.create_item_in_inventory("BARBARA",       ["SET_LOW_SHOES"])
	#objects.create_item_in_inventory("HAENDLER",      ["SET_LEATHER_BOOTS","SET_NORMAL_CLOTHES_6"])
	objects.create_item_in_inventory("LUISA",         ["SET_NORMAL_CLOTHES_2"])
	objects.create_item_in_inventory("FRANKLIN",      ["SET_NORMAL_CLOTHES_1"])
	objects.create_item_in_inventory("DORFBEWOHNERIN",["SET_RAT_MEAT"])
	objects.create_item_in_inventory("MCKANZEE",      ["SET_NORMAL_CLOTHES_1"])

	objects.create_item_in_inventory("SPIKE",         ["SET_LEATHER_BOOTS","SET_AMMOPACK_38"])
	objects.create_item_in_inventory("DANIEL",        ["SET_NORMAL_CLOTHES_3"])
	objects.create_item_in_inventory("VALORIE",       ["SET_HAIRSTYLE_MAGAZINE"])
	objects.create_item_in_inventory("LARSON",        ["SET_IRON_BAR"])
	objects.create_item_in_inventory("PHOEBE",        ["SET_LOW_SHOES"])
	objects.create_item_in_inventory("WULF",          ["SET_LEATHER_CLOTHES"])
	objects.create_item_in_inventory("KIA",           ["SET_LEATHER_GLOVES"])
	objects.create_item_in_inventory("HENRY",         ["SET_NORMAL_CLOTHES_2"])
	objects.create_item_in_inventory("MAGDA",         ["SET_NORMAL_CLOTHES_4"])
	objects.create_item_in_inventory("JIMMY",         ["SET_LOW_SHOES","SET_TEDDY_BEAR"])
	objects.create_item_in_inventory("JULIA",         ["SET_NECKLACE"])
	objects.create_item_in_inventory("ROBERT",        ["SET_SMALL_PICTURE_FRAME"])
	objects.create_item_in_inventory("MYRTHE",        ["SET_LEATHER_CAP","SET_NORMAL_CLOTHES_1"])
	#objects.create_item_in_inventory("JOHN",          [""])
	objects.create_item_in_inventory("SUZANNE",       ["SET_LOW_SHOES","SET_NORMAL_CLOTHES_5"])

def initItems():
	if not hasattr(data(), "patch_jan"):
		data().patch_jan = True

	# bei Steinbruch - Holzbalken
	objects.create_item_in_inventory(object="BUILDING_1582",equipment=["SET_GUN_POWDER","SET_DYNAMITE"])
	# in Waffenlager beim Traktor
	objects.create_item_in_inventory(object="BUILDING_2627",equipment=["SET_POWER_DRILL"])
	objects.create_item_in_inventory(object="BUILDING_2626",equipment=["SET_UZI"])
	objects.create_item_in_inventory(object="BUILDING_1984",equipment=["SET_COMPUTER_KEYBOARD"])
	objects.create_item_in_inventory(object="BUILDING_13064",equipment=['SET_M_16','SET_AMMOPACK_5_56_MM','SET_AMMOPACK_5_56_MM','SET_BULLET_PROOF_CLOTHES'])
	objects.create_item_in_inventory(object="BUILDING_15498",equipment=['SET_MP5','SET_UZI','SET_BERETTA_92F'])
	objects.create_item_in_inventory(object="BUILDING_13063",equipment=["SET_GUN_POWDER"]+ 8 *['SET_AMMOPACK_9_MM'])
	objects.create_item_in_inventory(object="BUILDING_13062",equipment=["SET_GIANT_KNIFE",'SET_AMMOPACK_7_62_54_MMR','SET_AMMOPACK_7_62_54_MMR','SET_AMMOPACK_5_7_MM','SET_AMMOPACK_5_7_MM'])
	# Eingang zum oberen Dorfteil
	objects.create_item_in_inventory(object="THE FALL_BUILDING_5218",equipment=["SET_BROKEN_SHOVEL"])
	objects.create_item_in_inventory(object="THE FALL_BUILDING_5220",equipment=["SET_CLUB"])
	# in Haus neben Weg nach oben im Dorf
	objects.create_item_in_inventory(object="BUILDING_7921",equipment=["SET_LEATHER_GLOVES"])
	# in Haus direkt vorm Haus des Dorfaeltesten
	objects.create_item_in_inventory(object="BUILDING_2880",equipment=["SET_AMMOPACK_45"])
	# in Kiste bei Haus des Dorfaeltesten
	objects.create_item_in_inventory(object="BUILDING_2768",equipment=["SET_COLT_ANACONDA"])
	# in Fass in Huette neben Tank
	objects.create_item_in_inventory(object="BUILDING_7931",equipment=["SET_WATER_SKIN"])
	# in Kiste in Haus neben Gueterwaggon
	objects.create_item_in_inventory(object="BUILDING_2871",equipment=["SET_BREAD", "SET_CHEESE"])
	# Muellcontainer beim Krankenhaus
	# objects.create_item_in_inventory(object="BUILDING_1547",equipment=["SET_HOLE_PUNCH"])
	# Waescheleine Dorfmitte
	objects.create_item_in_inventory(object="BUILDING_1680",equipment=["SET_NORMAL_CLOTHES_2"])
	# neben Bett in Haus des Einsiedlers
	#system.create_object(equipmenttype="SET_THROWING_KNIFE", x=548.33, y=544.46)
	objects.create_item_in_inventory(object="BUILDING_7883",equipment=["SET_THROWING_KNIFE"])
	# beim abgestuerzten Flugzeug
	system.create_object(equipmenttype="SET_RED_SHARD", x=360.17, y=531.15)
	# beim Wrack
	system.create_object(equipmenttype="SET_HEADPHONE", x=342.69, y=538.79)
	system.create_object(equipmenttype="SET_THROWING_KNIFE", x=342.47, y=538.87)
	
	# in Scheune auf Farm
	# objects.create_item_in_inventory(object="BUILDING_7844",equipment=["SET_HAIR_DRYER"])
	# in Farm-Haupthaus
	objects.create_item_in_inventory(object="BUILDING_7799",equipment=["SET_COOKING_POT"])
	objects.create_item_in_inventory(object="BUILDING_7789",equipment=["SET_WIRE_WHISK"])
	# in Scheune auf Farm
	objects.create_item_in_inventory(object="BUILDING_7830",equipment=["SET_AMMOPACK_357"])
	# auf Tisch in Krankenhaus
	system.create_object(equipmenttype="SET_MEDIPACK_BIG", x=506.81, y=680.96, id="medipack")
	objects.set_position_free("medipack", 506.81, 680.96, 0.6, grid= 'ZONE_3_BUILDING_2809_INTERIOR_GRID1')
	
	# Container
	objects.create_item_in_inventory(object="BUILDING_77",equipment=["SET_MP5_W_SILENCER"])
	# Fass
	# objects.create_item_in_inventory(object="BUILDING_1122",equipment=["SET_LANDMINE"])
	# Müllsack
	objects.create_item_in_inventory(object="BUILDING_2591",equipment=["SET_AMMOPACK_7_62NATO_MM"])
	# Kiste
	objects.create_item_in_inventory(object="BUILDING_2658",equipment=["SET_PROTECTIVE_GLOVES"])
	# Spind
	objects.create_item_in_inventory(object="BUILDING_7926",equipment=["SET_LEATHER_BOOTS"])
	# Kommode
	objects.create_item_in_inventory(object="BUILDING_7922",equipment=["SET_MEDIPACK_BIG"])
	# Doppelbett
	objects.create_item_in_inventory(object="BUILDING_2820",equipment=["SET_BELT"])
	# Schrankwand
	# objects.create_item_in_inventory(object="BUILDING_2921",equipment=["SET_ANTITANKMINE"])
	
	
	# ratskulls
	if not data().NoRatskulls:
		objects.create_item_in_inventory(object="RATSKULLS WAFFENLAGER A",equipment=["SET_MICRO_UZI","SET_AMMOPACK_9_MM"])
		objects.create_item_in_inventory(object="RATSKULLS WAFFENLAGER B",equipment=["SET_COLT_ANACONDA","SET_AMMOPACK_44","SET_AMMOPACK_44"])
		objects.create_item_in_inventory(object="RATSKULLS WAFFENLAGER C",equipment=["SET_MICRO_UZI","SET_AMMOPACK_9_MM"])
		objects.create_item_in_inventory(object="RATSKULLS WAFFENLAGER D",equipment=["SET_SIG_SAUER","SET_AMMOPACK_357"])
		objects.create_item_in_inventory(object="RATSKULLS BUNKER A",equipment=["SET_CALICO_M950","SET_AMMOPACK_9_MM"])
		objects.create_item_in_inventory(object="RATSKULLS BUNKER B",equipment=["SET_MICRO_UZI","SET_AMMOPACK_9_MM"])
		objects.create_item_in_inventory(object="RATSKULLS BUNKER C",equipment=["SET_CALICO_M950","SET_AMMOPACK_9_MM"])
		objects.create_item_in_inventory(object="RATSKULLS BUNKER D",equipment=["SET_SPECIAL_38","SET_AMMOPACK_38"])
		objects.create_item_in_inventory(object="RATSKULL_LEADER",equipment=["SET_SPECIAL_38","SET_AMMOPACK_38"])
		character.equip( "RATSKULLS WAFFENLAGER A", equipment="SET_MICRO_UZI" )
		character.equip( "RATSKULLS WAFFENLAGER B", equipment="SET_COLT_ANACONDA" )
		character.equip( "RATSKULLS WAFFENLAGER C", equipment="SET_MICRO_UZI" )
		character.equip( "RATSKULLS WAFFENLAGER D", equipment="SET_SIG_SAUER" )
		character.equip( "RATSKULLS BUNKER A", equipment="SET_CALICO_M950" )
		character.equip( "RATSKULLS BUNKER B", equipment="SET_MICRO_UZI" )
		character.equip( "RATSKULLS BUNKER C", equipment="SET_CALICO_M950" )
		character.equip( "RATSKULLS BUNKER D", equipment="SET_SPECIAL_38" )
		character.equip( "RATSKULL_LEADER", equipment="SET_SPECIAL_38" )

	objects.create_item_in_inventory(	object=data().Obj_KisteLuke,
						equipment=[	"SET_AMMOPACK_45_DUMDUM",
						"SET_AMMOPACK_45_DUMDUM",
						"SET_AMMOPACK_45_DUMDUM",
						"SET_HK_UMP_45"]
								)
	
	objects.create_item_in_inventory(data().Obj_KisteLuke,"SET_RATSKULL_DIARY", "Z3 RATSKULL_DIARY")
	objects.set_attribute("Z3 RATSKULL_DIARY", "generic_item", False)

	objects.create_item_in_inventory(	object="BUILDING_2548",
						equipment=[	"SET_AMMOPACK_9_MM",
						"SET_AMMOPACK_9_MM",
						"SET_AMMOPACK_9_MM",
						"SET_AMMOPACK_9_MM"]
								)

	objects.create_item_in_inventory(	object="BUILDING_2549",
						equipment=[	"SET_CALICO_M950"]
								)
	#ratskulltagebuch
	#objects.create_item_in_inventory(object=data().Obj_KisteLuke, equipment="SET_RATSKULL_DIARY", id="Z3 RATSKULL_DIARY")
	
	# Händler Andrew
	data().patch_jan = 2
	objects.create_item_in_inventory("HAENDLER",
					[
					"SET_MP5",#MP5
					"SET_COLT_45",#Colt 45er
					"SET_DESERT_EAGLE",#Desert Eagle
					"SET_WALTER_PPK",#Walther PPK
					"SET_GLOCK_21",#Glock 21
					"SET_MAC_10",#2 Mac 10
					"SET_MAC_10",
					"SET_REMINGTON_M870",#Remington M870
					"SET_M14",#M14
					"SET_SIMONOV_SKS",#Simonov SKS
					"SET_MACHETE",#Machete
					"SET_MOLOTOV_COCKTAIL",#2 Molotov
					"SET_MOLOTOV_COCKTAIL",
					"SET_AMMOPACK_9_MM",#6 Packen 9mm Munition
					"SET_AMMOPACK_9_MM",
					"SET_AMMOPACK_9_MM",
					"SET_AMMOPACK_9_MM",
					"SET_AMMOPACK_9_MM",
					"SET_AMMOPACK_9_MM",
					"SET_AMMOPACK_9_MM_SUBSONIC",#2 Packen 9mm Subsonicmunition
					"SET_AMMOPACK_9_MM_SUBSONIC",
					"SET_AMMOPACK_44",#2 Packen .44er Munition
					"SET_AMMOPACK_44",
					"SET_AMMOPACK_357_SUBSONIC",#1 Packen .357Sig Subsonicmunition
					"SET_AMMOPACK_45",#9 Packen .45er Munition
					"SET_AMMOPACK_45",
					"SET_AMMOPACK_45",
					"SET_AMMOPACK_45",
					"SET_AMMOPACK_45",
					"SET_AMMOPACK_45",
					"SET_AMMOPACK_45",
					"SET_AMMOPACK_45",
					"SET_AMMOPACK_45",
					"SET_AMMOPACK_45_SUBSONIC",#1 Packen .45er Subsonicmunition
					"SET_AMMOPACK_2_12_MM",#6 Packen 2“12Cal
					"SET_AMMOPACK_2_12_MM",
					"SET_AMMOPACK_2_12_MM",
					"SET_AMMOPACK_2_12_MM",
					"SET_AMMOPACK_2_12_MM",
					"SET_AMMOPACK_2_12_MM",
					"SET_AMMOPACK_50_AE_DUMDUM",#5 Packen .50AE Munition
					"SET_AMMOPACK_50_AE_DUMDUM",
					"SET_AMMOPACK_50_AE_DUMDUM",
					"SET_AMMOPACK_50_AE_DUMDUM",
					"SET_AMMOPACK_50_AE_DUMDUM",
					"SET_AMMOPACK_7_65_MM_SUBSONIC",#5 Packen 7,65mm Subsonicmunition
					"SET_AMMOPACK_7_65_MM_SUBSONIC",
					"SET_AMMOPACK_7_65_MM_SUBSONIC",
					"SET_AMMOPACK_7_65_MM_SUBSONIC",
					"SET_AMMOPACK_7_65_MM_SUBSONIC",
					"SET_AMMOPACK_7_62SOVJET_MM",#4 Packen 7,62x39 sovjet Munition
					"SET_AMMOPACK_7_62SOVJET_MM",
					"SET_AMMOPACK_7_62SOVJET_MM",
					"SET_AMMOPACK_7_62SOVJET_MM",
					"SET_AMMOPACK_7_62NATO_MM",#3 Packen 7,62x51 nato Munition
					"SET_AMMOPACK_7_62NATO_MM",
					"SET_AMMOPACK_7_62NATO_MM",
					"SET_AMMOPACK_5_56_MM",# 3 Packen 5,56 Munition
					"SET_AMMOPACK_5_56_MM",
					"SET_AMMOPACK_5_56_MM",
					"SET_BULLET_PROOF_CLOTHES",#Kugelsichere Kleidung
					"SET_LEATHER_CLOTHES",#Lederkleidung
					"SET_STEEL_HELMET",#Stahlhelm
					"SET_STEEL_CLAD_BOOTS",#Stahlkappenstiefel
					"SET_PROTECTIVE_GLOVES",#Schutzhandschuhe
					
					"SET_MEDIPACK_SMALL",#2x medipack_small
					"SET_MEDIPACK_SMALL",
					"SET_WATER_SKIN",#7 x water_skin
					"SET_WATER_SKIN",
					"SET_WATER_SKIN",
					"SET_WATER_SKIN",
					"SET_WATER_SKIN",
					"SET_WATER_SKIN",
					"SET_WATER_SKIN",
					"SET_WATER_DETECTOR",#2 x water_detector
					"SET_WATER_DETECTOR",
					"SET_TENT_CANVAS",#Tent_canvas
					"SET_MEDIPACK_BIG",#1x medipack_big
					"SET_MEAT_COOKED_TINY",#3 x meat_cooked_tiny
					"SET_MEAT_COOKED_TINY",
					"SET_MEAT_COOKED_TINY",
					"SET_MEAT_COOKED",#1 x meat_cooked
					"SET_CORN_COB",#corn cob
					"SET_CARROT",#2 x Carrot
					"SET_CARROT",
					"SET_BASIC_PICKLOCK",#Basic_picklock
					"SET_RIVETS",
					"SET_LONG_LEATHER_STRAP",
					"SET_OINTMANT_JAR",#Salbentopf
					"SET_OINTMANT_JAR",#Salbentopf
					"SET_GAS_CANISTER",# Benzinkanister
					"SET_GUN_POWDER",
					"SET_GUN_POWDER",
					"SET_GUN_POWDER",
					"SET_COAL_PILLS",
					"SET_SPIT",
					"SET_POT_ON_A_BAR"]
					)

	## fixme: hermans picklock
	system.create_object(equipmenttype="SET_SPECIAL_PICKLOCK",
		x=579.0,y=734.0,id=data().obj_HermansPicklock,
		direction=DIR_SOUTH)
	objects.pick_up_item_direct("HERMAN",data().obj_HermansPicklock)
	#objects.set_position_free(data().obj_HermansPicklock,x=579.84,y=734.78,z=0.9)
	
	# Bienenstöcke Z3
	objects.create_item_in_inventory( 'BUILDING_15559', equipment=[ 'SET_BEESWAX' ] )
	objects.create_item_in_inventory( 'BUILDING_15557', equipment=[ 'SET_BEESWAX', 'SET_BEESWAX' ] )
	objects.create_item_in_inventory( 'BUILDING_15555', equipment=[ 'SET_BEESWAX' ] )
	objects.create_item_in_inventory( 'BUILDING_15556', equipment=[ 'SET_BEESWAX' ] )

	# Items in Kisten
	objects.create_item_in_inventory( 'BUILDING_15361', equipment=[ 'SET_RED_SHARD', 'SET_MOLOTOV_COCKTAIL' ] )
	objects.create_item_in_inventory( 'BUILDING_7796', equipment=[ "SET_GUN_POWDER",'SET_AMMOPACK_9_MM_SUBSONIC', 'SET_AMMOPACK_50'] )
	objects.create_item_in_inventory( 'BUILDING_15363', equipment=[ 'SET_POTATO', 'SET_MEAT_RAW_HUMONGOUS', 'SET_WATER_BOTTLE', 'SET_ANTIDOTE' ] )
	objects.create_item_in_inventory( 'BUILDING_15366', equipment=[ 'SET_AMMOPACK_7_62NATO_MM', 'SET_AMMOPACK_7_62SOVJET_MM', 'SET_LEATHER_BOOTS' ] )
	objects.create_item_in_inventory( 'BUILDING_15379', equipment=[ 'SET_MEDIPACK_SMALL', 'SET_SET_OF_PICKLOCKS', 'SET_SMALL_SAND_SHOVEL',"SET_RASP" ] )
	objects.create_item_in_inventory( 'BUILDING_15382', equipment=[ 'SET_SMALL_SAND_BUCKET', 'SET_BOTTLE_OF_HOOCH', 'SET_BOTTLE_OF_BOOZE', 'SET_M_16' ] )
	objects.create_item_in_inventory( 'BUILDING_15411', equipment=[ 'SET_THROWING_KNIFE', 'SET_THROWING_KNIFE', 'SET_AMMOPACK_50' ] )
	objects.create_item_in_inventory( 'BUILDING_15439', equipment=[ 'SET_HAIR_DRYER', 'SET_P90_SMG', 'SET_MEDIPACK_SMALL', 'SET_LONG_LEATHER_STRAP', 'SET_AMMOPACK_5_7_MM' ] )
	objects.create_item_in_inventory( 'BUILDING_15440', equipment=[ 'SET_BASEBALL_BAT', 'SET_AMMOPACK_9_MM', 'SET_BULLET_CATCH' ] )
	objects.create_item_in_inventory( 'BUILDING_15441', equipment=[ 'SET_REEL_OF_STEEL_WIRE', 'SET_CAR_EXHAUST_PIPE', 'SET_STEYR_TMP' ] )

	data().patch_jan = 3
	# in Scheune auf Farm
	objects.create_item_in_inventory(object="BUILDING_7844",equipment=["SET_AMMOPACK_7_62_54_MMR"])

	data().patch_jan = 4
	objects.create_item_in_inventory(object='BUILDING_2921', equipment= ['SET_DART', 'SET_DART'] )
	objects.create_item_in_inventory(object='BUILDING_15411', equipment= 'SET_THROWING_KNIFE' )
	objects.create_item_in_inventory(object='BUILDING_7922', equipment= ['SET_SHURIKEN', 'SET_SHURIKEN'] )

	

def initHerbs():
	system.create_object(equipmenttype="SET_WOOD_GARLIC", x = 584.78, y = 476.77)
	system.create_object(equipmenttype="SET_ALOE_VERA", x = 599.05, y = 364.82)
	system.create_object(equipmenttype="SET_ALOE_VERA", x = 462.19, y = 446.212)
	system.create_object(equipmenttype="SET_WOOD_GARLIC", x = 353.22, y = 546.94)
	system.create_object(equipmenttype="SET_ALOE_VERA", x = 205.67, y = 604.65)
	system.create_object(equipmenttype="SET_ALOE_VERA", x = 235.35, y = 316.01)
	system.create_object(equipmenttype="SET_WOOD_GARLIC", x = 258.65, y = 213.44)
	system.create_object(equipmenttype="SET_ALOE_VERA", x = 432.24, y = 263.19)
	
def initExitZones():
	system.add_region( id = "REGION_EXIT_NORD", x1 = 0.00, y1 = 0.00, x2 = 799.00, y2 = 206.24 )
	system.register_exit(regionname = "REGION_EXIT_NORD" )
	system.add_region( id = "REGION_EXIT_SUED", x1 = 588.00, y1 = 991.00, x2 = 0.00, y2 = 784.00 )
	system.register_exit(regionname = "REGION_EXIT_SUED" )
	system.add_region( id = "REGION_EXIT_WEST", x1 = 0.00, y1 = 784.00, x2 = 200.00, y2 = 206.24 )
	system.register_exit(regionname = "REGION_EXIT_WEST" )
	system.add_region( id = "REGION_EXIT_OST", x1 = 799.00, y1 = 206.24, x2 = 600.00, y2 = 991.00 )
	system.register_exit(regionname = "REGION_EXIT_OST" )

def initFX():
	# aschetonne im dorf
	# system.start_effect_object(object="BUILDING_1695",node="aschetonne",parameter=fx_smoke_aschetonne)
	# tonne bei den ratskulls
	init_brennende_tonne("BUILDING_762")
	# tonne beim bauernhof
	init_brennende_tonne("BUILDING_45")
	# lagerfeuer beim Bauer
	system.start_effect_object("BUILDING_15527","effekt_feuer",fx_fire_lagerfeuer)
	sounds.play_3d_sound_object("campfire_small","BUILDING_15527",True)
	# lagerfeuer im dorf
	init_lagerfeuer("BUILDING_1590")
	# lagerfeuer bei den ratskulls
	init_lagerfeuer("BUILDING_1133")
	# lagerfeuer bei den felswohnungen
	init_lagerfeuer_small("BUILDING_15814")
	system.notify_timer(data().Timer_Luisa_Cry, 1000)
	sounds.play_3d_sound_object(sfx_id="cadaver_fly",object=data().Obj_BisonKadaver, loop=True)

def initMinimapMarkers():
	system.add_minimap_marker(449,347,"MM_002")#Mine belt
	system.add_minimap_marker(495,240,"MM_003")#Ratskulls weapon depot

def init_lagerfeuer_small(object_id):
	system.start_effect_object(object = object_id,node="asche",parameter=fx_fire_pilar_1)
	sounds.play_3d_sound_object(sfx_id="campfire_small",object=object_id,loop=True)

def init_lagerfeuer(object_id):
	system.start_effect_object(object=object_id,node="effekt_feuer",parameter=fx_fire_lagerfeuer)
	#system.start_effect_object(object=object_id,node="effekt_feuer",parameter=fx_smoke_lagerfeuer)
	system.start_effect_object(object=object_id,node="effekt_feuer01",parameter=fx_fire_lagerfeuer_01)
	system.start_effect_object(object=object_id,node="effekt_feuer02",parameter=fx_fire_lagerfeuer_02)
	system.start_effect_object(object=object_id,node="effekt_feuer03",parameter=fx_fire_lagerfeuer_03)
	system.start_effect_object(object=object_id,node="effekt_feuer04",parameter=fx_fire_lagerfeuer_04)
	sounds.play_3d_sound_object(sfx_id="campfire_big",object=object_id,loop=True)

def init_brennende_tonne(object_id):
	#system.start_effect_object(object=object_id,node="sort0",parameter=fx_smoke_brennende_tonne)
	system.start_effect_object(object=object_id,node="sort1",parameter=fx_fire_brennende_tonne)
	sounds.play_3d_sound_object(sfx_id="campfire_small",object=object_id,loop=True)

def initAggro():
	# auf aggro schalten
	if not data().NoRatskulls:
		objects.set_attribute(object="RATSKULLS WAFFENLAGER A", attribute="foes", value=["UISPIELER"])
		objects.set_attribute(object="RATSKULLS WAFFENLAGER B", attribute="foes", value=["UISPIELER"])
		objects.set_attribute(object="RATSKULLS WAFFENLAGER C", attribute="foes", value=["UISPIELER"])
		objects.set_attribute(object="RATSKULLS WAFFENLAGER D", attribute="foes", value=["UISPIELER"])

def on_trade(target,operator):
	if not object_events.on_trade(target,operator):
		return False
	if target=="HAENDLER":
		objects.cancel_commandos(target)
		if get_location("HAENDLER") == 1:
			prohibit_activity(target)
		lambda_string = 'system.trading_screen(trader="%s",char="%s")' %(target,operator)
		objects.turn_to_object(target, operator, callback=["ONEND", Lambda(lambda_string)])
	return None

def on_exit_trader( trader_id, negotiator_id, profit ):
	allow_activity(trader_id)
	return object_events.on_exit_trader( trader_id, negotiator_id, profit)


def on_weapon_ignition(weapon_id,weapon_type,x,y,z):
	#print "onWeaponIgnition",weapon_type,x,y,z
	if weapon_type=="SET_C4_REMOTE_CONTROL" and x > 502 and x < 509 and y > 233 and y < 241:
		if not data().bunker_gesprengt:
			data().bunker_gesprengt = True
			destroy_building_bunker()
			system.notify_timer(
				timer=data().Timer_BunkerRedskullsAppear, 
				delay=data().Timervalue_BunkerRedskullsAppear)
			character.add_experience_party(data().Exp_Bunker_Gesprengt)

def ratskull_hears_exploding_cow():
	if data().ratskull_spotted_player:
		return

	# suspicious ratskull guard; but only for first exploding cow
	if not data().ratskull_has_heard_exploding_cow:
		data().ratskull_has_heard_exploding_cow = True
		objects.move_to( "RATSKULLS WAFFENLAGER A", 448.82, 331.12, "landscape", MT_SLOW, callback=["ONEND",onRatskullMovesToCow])

def onRatskullMovesToCow(id):
	ratskull_A_arrives_at_minebelt()

def ratskull_A_arrives_at_minebelt():
	if data().ratskull_spotted_player:
		return

	# suspicious ratskull looks at exploded cows
	if not data().ratskull_A_at_minebelt:
		data().ratskull_A_at_minebelt = True
		# todo vielleicht noch auf destroyed abfragen
		# no player char visible
		objects.turn_to_object( "RATSKULLS WAFFENLAGER A", "RATSKULLS WAFFENLAGER B")
		character.play_animation( "RATSKULLS WAFFENLAGER A", "CM_NPC_STEHEN_WARTEN_1" )
		dialogs.initDlg_074_DeadCowsSpotted()
		objects.move_to( "RATSKULLS WAFFENLAGER A", 445.45, 340.35 , "landscape")
		objects.turn_to_position( "RATSKULLS WAFFENLAGER A", 444.61, 342.83 )

		objects.move_to( "RATSKULLS WAFFENLAGER B", 446.82, 331.12 , "landscape")
		objects.move_to( "RATSKULLS WAFFENLAGER B", 443.56, 343.16 , "landscape")
		objects.turn_to_position( "RATSKULLS WAFFENLAGER B", 444.61, 342.83 )

		objects.move_to( "RATSKULLS WAFFENLAGER C", 448.82, 331.12 , "landscape")
		objects.move_to( "RATSKULLS WAFFENLAGER C", 446.75, 343.2 , "landscape")
		objects.turn_to_position( "RATSKULLS WAFFENLAGER C", 444.61, 342.83, callback=["ONEND",onRatskullsComesToSeeCow2])
		
def onRatskullsComesToSeeCow2(id):
	if UnEquip_Weapon_Direct("RATSKULLS WAFFENLAGER B"):
		character.play_animation("RATSKULLS WAFFENLAGER B", "CM_NPC_STEHEN_TIER_AUSWEIDEN_START")
		character.play_animation("RATSKULLS WAFFENLAGER B", "CM_NPC_STEHEN_TIER_AUSWEIDEN_LOOP")
		character.play_animation("RATSKULLS WAFFENLAGER B", "CM_NPC_STEHEN_TIER_AUSWEIDEN_ENDE", callback = ['ONEND', Is_Equip_Weapon])
	if UnEquip_Weapon_Direct("RATSKULLS WAFFENLAGER C"):
		character.play_animation("RATSKULLS WAFFENLAGER C", "CM_NPC_STEHEN_TIER_AUSWEIDEN_START")
		character.play_animation("RATSKULLS WAFFENLAGER C", "CM_NPC_STEHEN_TIER_AUSWEIDEN_LOOP")
		character.play_animation("RATSKULLS WAFFENLAGER C", "CM_NPC_STEHEN_TIER_AUSWEIDEN_ENDE", callback = ['ONEND', Is_Equip_Weapon])

	if objects.get_x("RATSKULLS WAFFENLAGER C") < 447.75 and \
		objects.get_x("RATSKULLS WAFFENLAGER C") > 445.75 and \
		objects.get_y("RATSKULLS WAFFENLAGER C") < 344.2 and \
		objects.get_y("RATSKULLS WAFFENLAGER C") > 342.2:
		ratskull_C_arrives_at_cow()

def ratskull_C_arrives_at_cow():
	if data().ratskull_spotted_player:
		return

	# last ratskull arrives
	# they start talking about the dead cows
	dialogs.initDlg_075_DeadCowsDiscussion()

def ratskull_says_something_about_dead_cows():
	if (not objects.is_destroyed("RATSKULLS WAFFENLAGER A") and
		not objects.is_destroyed("RATSKULLS WAFFENLAGER B") and
		not objects.is_destroyed("RATSKULLS WAFFENLAGER C")):
			if data().ratskulls_discuss_dead_cows < 4:
				if data().ratskulls_discuss_dead_cows == 1:
					data().ratskulls_discuss_dead_cows += 1
					dialogs.initDlg_076_DeadCowsStrange1()
				elif data().ratskulls_discuss_dead_cows == 2:
					data().ratskulls_discuss_dead_cows += 1
					dialogs.initDlg_077_DeadCowsStrange2()
				elif data().ratskulls_discuss_dead_cows == 3:
					data().ratskulls_discuss_dead_cows += 1
					dialogs.initDlg_078_DeadCowsStrange3()
			elif data().ratskulls_discuss_dead_cows >= 4:
				if not objects.is_destroyed("RATSKULLS WAFFENLAGER A"):
					objects.move_to( "RATSKULLS WAFFENLAGER A", x=446.69, y=303.24, grid="landscape", speed=MT_SLOW )
					objects.turn_to_direction("RATSKULLS WAFFENLAGER A", DIR_SOUTH)
				if not objects.is_destroyed("RATSKULLS WAFFENLAGER B"):
					objects.move_to( "RATSKULLS WAFFENLAGER B", x=521.16, y=290.3, grid="landscape", speed=MT_SLOW )
					objects.turn_to_direction("RATSKULLS WAFFENLAGER B", DIR_SOUTH_WEST)
				if not objects.is_destroyed("RATSKULLS WAFFENLAGER C"):
					objects.move_to( "RATSKULLS WAFFENLAGER C", x=523.72, y=295.44, grid="landscape", speed=MT_SLOW )
					objects.turn_to_direction("RATSKULLS WAFFENLAGER C", DIR_WEST)

def ratskull_spotted_player(enemys=None):
	# ratskull guards see player char
	if not data().ratskull_spotted_player:
		data().ratskull_spotted_player = True
		
		for ratskull in ["RATSKULLS WAFFENLAGER A","RATSKULLS WAFFENLAGER B",
				"RATSKULLS WAFFENLAGER C","RATSKULLS WAFFENLAGER D"]:
			if not objects.is_destroyed(ratskull):
				objects.cancel_commandos(ratskull)
				if Is_Equip_Weapon(ratskull):
					if ratskull != "RATSKULLS WAFFENLAGER D":
						if len(enemys):
							enemys_ = random.choice(enemys)
							if not objects.is_destroyed(enemys_):
								objects.attack(ratskull, enemys_)
			
		dialogs.initDlg_073_PlayerCharSpotted()
		
		if not objects.is_destroyed("RATSKULLS WAFFENLAGER D"):
			objects.move_to( "RATSKULLS WAFFENLAGER D", x=496, y=252, grid="landscape")
		onRatskullsAlarmOthers("RATSKULLS WAFFENLAGER D")

def onRatskullsAlarmOthers(id):
	ratskull_bunker_alert()

def ratskull_bunker_alert():
	#print "rutscull_bunker_alert"
	if not data().ratskull_bunker_alerted:
		data().ratskull_bunker_alerted = True
		dialogs.initDlg_079_BunkerAlert()
		if not objects.is_destroyed("RATSKULLS WAFFENLAGER D"):
			for id in ["RATSKULLS WAFFENLAGER A", "RATSKULLS WAFFENLAGER B", "RATSKULLS WAFFENLAGER C"]:
				if objects.is_destroyed(id):
					if Is_Equip_Weapon("RATSKULLS WAFFENLAGER D"):
						enemys = character.get_visible_enemies(id)
						if len(enemys):
							enemys_ = random.choice(enemys)
							if not objects.is_destroyed(enemys_):
								objects.attack("RATSKULLS WAFFENLAGER D", enemys_)
								return
			objects.move_to("RATSKULLS WAFFENLAGER D",446.49, 329.30, callback = ['ONEND', Lambda('system.notify_timer( data().Timer_ratskull_discuss_dead_cows,random.randint(4, 8) * 1000 )')])
		
		if (not objects.is_destroyed("RATSKULL_LEADER")):
			enemy_script.enter_building_to_position(char ='RATSKULL_LEADER' , speed = MT_FAST, house = 'BUILDING_10532', grid ='ZONE_3_BUILDING_10532_INTERIOR_GRID', x = 516.51, y = 236.16)
			objects.turn_to_direction("RATSKULL_LEADER", 270, callback = ['ONEND', Bunker_Abschliesen])
		if (not objects.is_destroyed("RATSKULLS BUNKER A")):
			enemy_script.enter_building_to_position(char ='RATSKULLS BUNKER A' , speed = MT_FAST, house = 'BUILDING_10532', grid ='ZONE_3_BUILDING_10532_INTERIOR_GRID', x = 512.72, y = 239.14)
			objects.turn_to_direction("RATSKULLS BUNKER A", 270, callback = ['ONEND', Bunker_Abschliesen])
		if (not objects.is_destroyed("RATSKULLS BUNKER C")): 
			enemy_script.enter_building_to_position(char ='RATSKULLS BUNKER C' , speed = MT_FAST, house = 'BUILDING_10532', grid ='ZONE_3_BUILDING_10532_INTERIOR_GRID', x = 516.54, y = 239.25)
			objects.turn_to_direction("RATSKULLS BUNKER C", 270, callback = ['ONEND', Bunker_Abschliesen])
		if (not objects.is_destroyed("RATSKULLS BUNKER B")):
			enemy_script.enter_building_to_position(char ='RATSKULLS BUNKER B' , speed = MT_FAST, house = 'BUILDING_10532', grid ='ZONE_3_BUILDING_10532_INTERIOR_GRID', x = 514.53, y = 239.12)
			objects.turn_to_direction("RATSKULLS BUNKER B", 270, callback = ['ONEND', Bunker_Abschliesen])
		if (not objects.is_destroyed("RATSKULLS BUNKER D")):
			enemy_script.enter_building_to_position(char ='RATSKULLS BUNKER D' , speed = MT_FAST, house = 'BUILDING_10532', grid ='ZONE_3_BUILDING_10532_INTERIOR_GRID', x = 516.59, y = 237.64)
			objects.turn_to_direction("RATSKULLS BUNKER D", 270, callback = ['ONEND', Bunker_Abschliesen])
	
			objects.set_immortal_state("RATSKULLS BUNKER A", True)
			objects.set_immortal_state("RATSKULLS BUNKER B", True)
			objects.set_immortal_state("RATSKULLS BUNKER C", True)
			objects.set_immortal_state("RATSKULLS BUNKER D", True)
			objects.set_immortal_state("RATSKULL_LEADER", True)

def Bunker_Abschliesen(id):
	data().Bunker_Abschliesen += 1
	if data().Bunker_Abschliesen >= 5:
		Test_Bunker_Abschliesen()
		data().Bunker_Abschliesen = 0

def Test_Bunker_Abschliesen():
	#print "bunker abschliessen"
	for id in ['RATSKULL_LEADER', 'RATSKULLS BUNKER A', 'RATSKULLS BUNKER B', 'RATSKULLS BUNKER C', 'RATSKULLS BUNKER D']:
		if objects.get_attribute(id, 'grid') != 'ZONE_3_BUILDING_10532_INTERIOR_GRID':
			if id == 'RATSKULL_LEADER':
				objects.set_position('RATSKULL_LEADER' , 516.51, 236.16, 'ZONE_3_BUILDING_10532_INTERIOR_GRID')
			elif id == 'RATSKULLS BUNKER A':
				objects.set_position('RATSKULLS BUNKER A' , 512.72, 239.14, 'ZONE_3_BUILDING_10532_INTERIOR_GRID')
			elif id == 'RATSKULLS BUNKER B':
				objects.set_position('RATSKULLS BUNKER B' , 514.53, 239.12, 'ZONE_3_BUILDING_10532_INTERIOR_GRID')
			elif id == 'RATSKULLS BUNKER C':
				objects.set_position('RATSKULLS BUNKER C' , 516.54, 239.25, 'ZONE_3_BUILDING_10532_INTERIOR_GRID')
			elif id == 'RATSKULLS BUNKER D':
				objects.set_position('RATSKULLS BUNKER D' , 516.59, 237.64, 'ZONE_3_BUILDING_10532_INTERIOR_GRID')
	

def ratskulls_bunker_appear():
	# bunker damaged
	#print "ratscull bunker appear"
	if objects.is_destroyed('ALTER_EGO'):
		return
	
	dist = objects.get_distance("ALTER_EGO","BUILDING_BUNKER_SPRENGUNG")
	if dist > 50.0:
		objects.cancel_commandos("ALTER_EGO")
		objects.set_position_free("ALTER_EGO", 496.70, 269.08, 0.0, grid="landscape")

	system.start_cutscene()
	system.set_camera_view(CAMVIEW_BUNKER_RATSKULLS)
	objects.set_immortal_state("RATSKULLS BUNKER A", False)
	objects.set_immortal_state("RATSKULLS BUNKER B", False)
	objects.set_immortal_state("RATSKULLS BUNKER C", False)
	objects.set_immortal_state("RATSKULLS BUNKER D", False)
	objects.set_immortal_state("RATSKULL_LEADER", False)

	#objects.set_position_free("RATSKULL_LEADER", 521.5, 237, 1 )
	character.play_animation("RATSKULL_LEADER", "CM_RENNEN_WAFFENLOS" )
	character.play_animation("RATSKULL_LEADER", "CM_RENNEN_WAFFENLOS_ENDSCHRITT" )
	character.play_animation("RATSKULL_LEADER", "CM_NPC_SITZEN_BANK_AUFSTEHEN" )

	#objects.set_position_free("RATSKULLS BUNKER A", 511, 237, 1 )
	character.play_animation("RATSKULLS BUNKER A", "CM_RENNEN_WAFFENLOS_ENDSCHRITT" )
	character.play_animation("RATSKULLS BUNKER A", "CM_NPC_SITZEN_BANK_AUFSTEHEN" )

	#objects.set_position_free("RATSKULLS BUNKER B", 514.5, 237, 1 )
	character.play_animation("RATSKULLS BUNKER B", "CM_RENNEN_WAFFENLOS" )
	character.play_animation("RATSKULLS BUNKER B", "CM_RENNEN_WAFFENLOS_ENDSCHRITT" )
	character.play_animation("RATSKULLS BUNKER B", "CM_NPC_SITZEN_BANK_AUFSTEHEN" )

	#objects.set_position_free("RATSKULLS BUNKER C", 518, 237, 1 )
	character.play_animation("RATSKULLS BUNKER C", "CM_RENNEN_WAFFENLOS" )
	character.play_animation("RATSKULLS BUNKER C", "CM_RENNEN_WAFFENLOS" )
	character.play_animation("RATSKULLS BUNKER C", "CM_RENNEN_WAFFENLOS_ENDSCHRITT" )
	character.play_animation("RATSKULLS BUNKER C", "CM_NPC_SITZEN_BANK_AUFSTEHEN" )

	#objects.set_position_free("RATSKULLS BUNKER D", 521.5, 237, 1 )
	character.play_animation("RATSKULLS BUNKER D", "CM_RENNEN_WAFFENLOS" )
	character.play_animation("RATSKULLS BUNKER D", "CM_RENNEN_WAFFENLOS" )
	character.play_animation("RATSKULLS BUNKER D", "CM_RENNEN_WAFFENLOS" )
	character.play_animation("RATSKULLS BUNKER D", "CM_RENNEN_WAFFENLOS_ENDSCHRITT" )
	character.play_animation("RATSKULLS BUNKER D", "CM_NPC_SITZEN_BANK_AUFSTEHEN" )

	objects.move_to("RATSKULLS BUNKER A",501.8,235.4)
	objects.move_to("RATSKULLS BUNKER B",502.6,236.2)
	objects.move_to("RATSKULLS BUNKER C",503.11,237.0)
	objects.move_to("RATSKULLS BUNKER D",502.4,239.4)
	objects.move_to("RATSKULL_LEADER",502.5,238.0,callback=["ONEND",on_RatskullsLeaveBunkerCam1])

	objects.move_to("RATSKULL_LEADER",496.5,241.0,"landscape",speed=MT_SLOW, callback=["ONEND",on_RatskullsLeaveBunkerCam2])

	objects.turn_to_object("RATSKULLS BUNKER A","ALTER_EGO", callback=["ONEND", on_RatskullsLeaveBunkerHandsUp])
	objects.turn_to_object("RATSKULLS BUNKER B","ALTER_EGO", callback=["ONEND", on_RatskullsLeaveBunkerHandsUp])
	objects.turn_to_object("RATSKULLS BUNKER C","ALTER_EGO", callback=["ONEND", on_RatskullsLeaveBunkerHandsUp])
	objects.turn_to_object("RATSKULLS BUNKER D","ALTER_EGO", callback=["ONEND", on_RatskullsLeaveBunkerHandsUp])

def on_RatskullsLeaveBunkerHandsUp(char_id):
	data().ratskulls_hands_up[char_id] = True

def ratskulls_bunker_bag_for_life(id):
	end_cutscene(chars=["RATSKULL_LEADER","ALTER_EGO"])
	objects.turn_to_object("RATSKULL_LEADER","ALTER_EGO")
	dialogs.initDlg_100_RatskullLeaderWillNichtSterben()

def on_RatskullsLeaveBunkerCam1(id):
	objects.cancel_commandos("ALTER_EGO")
	objects.set_position("ALTER_EGO",490.3,241.4)
	objects.move_to("ALTER_EGO",494.0,242.0,"landscape",speed=MT_SLOW)
	system.set_camera_view(CAMVIEW_BUNKER_OUT)

def on_RatskullsLeaveBunkerCam2(id):
	system.set_camera_view(CAMVIEW_BUNKER_FAR)
	objects.cancel_commandos("RATSKULL_LEADER")
	objects.move_to("RATSKULL_LEADER",496.5,241.0,"landscape",speed=MT_SLOW)
	objects.turn_to_object("ALTER_EGO","RATSKULL_LEADER",callback=["ONEND",ratskulls_bunker_bag_for_life])
	objects.turn_to_object("RATSKULL_LEADER","ALTER_EGO")

def ratskulls_bunker_escaped(id):
	objects.set_active_state(id, INACTIVE)
	data().Ratskulls_Bunker = data().Ratskulls_Bunker + 1
	if data().Ratskulls_Bunker >= 4:
		#system.set_qb_entry_state(data().QB_004, COMPLETE)
		system.notify_timer(timer=data().Timer_Zone4Comment, delay=data().Timervalue_Zone4Comment)


# todo: quests absichern/auf failed stellen, wenn einer der noch benötigten questchars abnibbelt
# todo: lootliste für waffenlager
# todo: lootliste für bunker
def on_pick_up( character_id, item_id, item_type ):
	print 'debug: on_pick_up', character_id, item_id, item_type 
	if item_id == "Z3 RATSKULL_DIARY":
		if not data().ratskull_tagebuch_gelesen:
			dialogs.initDlg_131_SpielerFindetRatskulltagebuch()
	
	if item_id == data().obj_HermansPicklock:
		if objects.is_destroyed("HERMAN"):
			return True
		
		if data().spieler_hat_dietrich:
			return True
	
		if objects.get_attribute(character_id,"pick_pocket") >= 80 :
			if not data().spieler_hat_dietrich:
				dialogs.initDlg_120_SpielerKlautDietrich()
				return True
			else:
				return True
		else:
			dialogs.initDlg_121_SpielerUntersuchtDietrich()
			return False
			
	return object_events.on_pick_up( character_id, item_id, item_type)

def on_enemy_spotted(object_id):
	#print "[debug: on_enemy_spotted:",object_id,"]"
	enemys = character.get_visible_enemies(object_id)
	
	if object_id in RATSKULLS_BUNKER and len(enemys):
		ratskull_spotted_player(enemys)
		attack_enemy(object_id,enemys)
	if object_id == 'HUMVEE_Z3':
		return True
	return None
		

def on_sector_cleared(object_id):
	#print "[on_sector_cleared(",object_id,")]"
	if object_id in RATSKULLS_BUNKER:
		for id in RATSKULLS_BUNKER:
			if not objects.is_destroyed(id):
				if (character.get_visible_enemies(id)):
					return
		if not objects.is_destroyed("RATSKULLS WAFFENLAGER A"):
			objects.move_to( "RATSKULLS WAFFENLAGER A", x=446.69, y=303.24, grid="landscape", speed=MT_SLOW )
			objects.turn_to_direction("RATSKULLS WAFFENLAGER A", DIR_SOUTH)
		if not objects.is_destroyed("RATSKULLS WAFFENLAGER B"):
			objects.move_to( "RATSKULLS WAFFENLAGER B", x=521.16, y=290.3, grid="landscape", speed=MT_SLOW )
			objects.turn_to_direction("RATSKULLS WAFFENLAGER B", DIR_SOUTH_WEST)
		if not objects.is_destroyed("RATSKULLS WAFFENLAGER C"):
			objects.move_to( "RATSKULLS WAFFENLAGER C", x=523.72, y=295.44, grid="landscape", speed=MT_SLOW )
			objects.turn_to_direction("RATSKULLS WAFFENLAGER C", DIR_WEST)


def attack_enemy(char, enemys=None):
	#objects.cancel_commandos(char)
	if not objects.is_destroyed(char):
		if enemys == None:
			enemys = character.get_visible_enemies(char)
			if not len(enemys):
				return False
		enemys_ = random.choice(enemys)
		if not objects.is_destroyed(enemys_):
			objects.attack(char, enemys_)
	return None

def on_attack(operator, target):
	#print "[debug: on_attack:",operator,target,"]"
	
	if not hasattr(data(), "has_been_attacked"):
		data().has_been_attacked = []
	if target in data().has_been_attacked:
		return
	
	if target in ["RATSKULLS A", "RATSKULLS B", "RATSKULLS C"]:
		enemys = character.get_visible_enemies(operator)
		for id in ["RATSKULLS A", "RATSKULLS B", "RATSKULLS C"]:
			if not objects.is_destroyed(id):
				if not id in data().has_been_attacked:
					data().has_been_attacked.append(id)
					data().BesoffeneRatskullSchlaeft = False
					if not objects.has_attribute(id, "foes"):
						objects.set_attribute(object=id, attribute="foes", value=["UISPIELER"])
					prohibit_activity(id)
					objects.turn_to_object(id, operator)
					character.arm_direct(id)
			#else:
				#if len(enemys) and not objects.is_destroyed(target):
					#enemys_ = random.choice(enemys)
					#if not objects.is_destroyed(enemys_):
						#objects.attack(target, enemys_)

	if target in ["RATSKULLS WAFFENLAGER A","RATSKULLS WAFFENLAGER B","RATSKULLS WAFFENLAGER C","RATSKULLS WAFFENLAGER D"]:
		for id in ["RATSKULLS WAFFENLAGER A","RATSKULLS WAFFENLAGER B","RATSKULLS WAFFENLAGER C","RATSKULLS WAFFENLAGER D"]:
			if not objects.is_destroyed(id):
				if not id in data().has_been_attacked:
					data().has_been_attacked.append(id)
				
					if not objects.is_destroyed(operator):
						enemys = [operator]
						ratskull_spotted_player(enemys)
						attack_enemy(id, enemys)
		
def can_exchange( character_id, target_id, item_id, item_type ):
	if (item_type in ["SET_BISON_MEAT"] 
		and target_id == "DONALD RUMS"
		and character_id == "ALTER_EGO"):
			if not data().donald_has_bisonmeat:
				if system.get_qb_entry_state(data().QB_005) == UNCOMPLETE:
					return True
			
	if (item_type in ["SET_TIGER_MEAT"] 
		and target_id == "DONALD RUMS"
		and character_id == "ALTER_EGO"):
			if not data().donald_has_tigermeat:
				if system.get_qb_entry_state(data().QB_005) == UNCOMPLETE:
					return True
	
	if item_type == "SET_WATER_SKIN":
		if target_id == "MCKANZEE":
			if (character_id == "ALTER_EGO" and system.get_qb_entry_state(data().QB_009) == UNCOMPLETE):
				return True
			else:
				return False
		elif target_id not in system.get_pcs():
				return False 
	
	if (item_id == data().obj_Autobatterie or item_type == "SET_CAR_BATTERY"):
		if item_id == data().obj_Autobatterie:
			if (target_id == "EINSIEDLER"
				and character_id == "ALTER_EGO" 
				and system.get_qb_entry_state(data().QB_008) == UNCOMPLETE):
					return True
		
		elif item_type == "SET_CAR_BATTERY":
			if target_id == "EINSIEDLER":
				if (character_id == "ALTER_EGO" and system.get_qb_entry_state(data().QB_008) == UNCOMPLETE):
					return True
				else:
					return False
			elif target_id not in system.get_pcs():
				return False

	return object_events.can_exchange( character_id, target_id, item_id, item_type )

def on_exchange( character_id, target_id, item_id, item_type ):
	#print "exchange %s %s %s %s" % (character_id, target_id, item_id, item_type)
	
	if item_type == "SET_BISON_MEAT":
		if (target_id == "DONALD RUMS" and character_id == "ALTER_EGO"):
			if (not system.get_qb_entry_state(data().QB_005) == COMPLETE):
				if not data().donald_has_bisonmeat:
					data().meat_given_donald += 1
					data().donald_has_bisonmeat = True
					if data().meat_given_donald == 2:
						dialogs.initDlg_010_Sprengmeister_BekommtFleisch()
				return True
	
	if item_type == "SET_TIGER_MEAT":
		if (target_id == "DONALD RUMS" and character_id == "ALTER_EGO"):
			if (not system.get_qb_entry_state(data().QB_005) == COMPLETE):
				if not data().donald_has_tigermeat:
					data().meat_given_donald += 1
					data().donald_has_tigermeat = True
					if data().meat_given_donald == 2:
						dialogs.initDlg_010_Sprengmeister_BekommtFleisch()
					return True
	
	if item_type == "SET_WATER_SKIN":
		if (target_id == "MCKANZEE" and character_id == "ALTER_EGO"):
			if system.get_qb_entry_state(data().QB_009) == UNCOMPLETE:
				data().mckanzee_given_water += 1
				if data().mckanzee_given_water == 3:
					dialogs.initCutscene_Dlg_031_McKanzee_BekommtWasser()
				return True

	if item_id == data().obj_Autobatterie:
		if (target_id == "EINSIEDLER" and character_id == "ALTER_EGO"):
			if system.get_qb_entry_state(data().QB_008) == UNCOMPLETE:
				data().car_battery_given = True
				dialogs.initDlg_032_Einsiedler_BekommtBatterie()
				return True
	if (target_id == "LUKE_Z3" and (item_id == data().obj_HermansPicklock or
		item_type == 'SET_SPECIAL_PICKLOCK')):
		dialogs.initCutscene_112_LukeKnacktDasSchloss(exchange_lockpick=False)
		return True

	return object_events.on_exchange( character_id, target_id, item_id, item_type )

## Spawns Bergtigerin
def spawnBergtigerin(state):
	if not objects.is_destroyed("BERGTIGERIN"):
		if (state == ACTIVE):
			if not data().BergtigerAktiv:
				objects.set_active_state("BERGTIGERIN",state)
				objects.cancel_commandos("BERGTIGERIN")
				objects.set_position("BERGTIGERIN", 200.84, 588.05)
				objects.move_to("BERGTIGERIN", 219.90, 592.21, grid="landscape", speed=MT_FAST)
				data().BergtigerAktiv = True
		else:
			if data().BergtigerAktiv:
				data().BergtigerAktiv = False
				objects.cancel_commandos("BERGTIGERIN")
				objects.move_to("BERGTIGERIN", 200.84, 588.05, grid="landscape", speed=MT_FAST, callback=["ONEND", bergtigerinEnde])

def bergtigerinEnde(id):
	objects.set_active_state("BERGTIGERIN",INACTIVE)

## Timer Trigger für die Tigerin
def starteTimerBergtigerin():
	#print "[debug starteTimerBergtigerin() ]"
	clock = system.get_mission_time().get_day_time()
	if (clock >= time("22:45:00") or clock < time("3:15:00")):
		system.notify_timer(data().Timer_BergTigerChecker,data().Timervalue_BergtigerChecker)

#prueffunktionen: kann ein char ein lock (kiste luke) oeffnen
def can_open_lock(id, blast=False):
	data().spieler_am_schloss = ""
	if can_open_lock_helper(id, blast):
		data().spieler_am_schloss = id
		#print "can_open_lock_1"
		#print data().spieler_am_schloss
		return True
	elif id == "ALTER_EGO":
		for pc in system.get_pcs():
			if can_open_lock_helper(pc, blast):
				#print "can_open_lock_2"
				if objects.get_distance(pc, data().Obj_KisteLuke) <= 15.0:
					data().spieler_am_schloss = pc
					#print "can_open_lock_3"
					#print data().spieler_am_schloss
					return True
		return False
	return False

def can_open_lock_helper(char, blast=False):
	picklocks = []
	if blast:
		picklocks = ["SET_GUN_POWDER"]
		if objects.has_attribute(char,"explosives_talents"):
			if ("blast_locks" in objects.get_attribute(char,"explosives_talents")):
				if objects.count_in_inventory( char, picklocks[0] ):
					return True
		
	else:
		picklocks = ["SET_BASIC_PICKLOCK", "SET_VAMPED_PICKLOCK_SET", "SET_SET_OF_PICKLOCKS"]
		
		if not len(picklocks):
			return False
		
		for picklock in picklocks:
			if( objects.count_in_inventory( char, picklock ) ):
				if objects.has_attribute(char,"lock_pick") and objects.has_attribute(char,"dexterity"):
					if (objects.get_attribute(char,"lock_pick") >= 75):
						return True
	return False

def on_destroy_building_bunker_end(id):
	#print " >>> on_destroy_building_bunker_end"
	objects.fade_node(object="BUILDING_BUNKER_SPRENGUNG",node="parts",time=300)
	objects.set_active_state(object="ZONE_3_BUILDING_10532", state=INACTIVE)

def on_destroy_building_bunker_start(id):
	#print " >>> on_destroy_building_bunker_start"
	system.start_effect_object(object="BUILDING_BUNKER_SPRENGUNG",node="explosion_main",parameter=[FX_EXPLOSION_COMBO_1,0,2000,2.0,100.0])
	system.start_effect_object(object="BUILDING_BUNKER_SPRENGUNG",node="explosion_rotor",parameter=[FX_EXPLOSION_COMBO_1,200,1500,0.5,0.0])
	system.start_effect_object(object="BUILDING_BUNKER_SPRENGUNG",node="explosion_tuer",parameter=[FX_EXPLOSION_COMBO_1,300,2000,1.5,10.0])
	sounds.play_3d_sound_object(sfx_id="explosion_bunker",
		object="BUILDING_BUNKER_SPRENGUNG")

def init_destroy_bunker_reposition_interior():
	int_objs = ['BUILDING_13069','BUILDING_13064','BUILDING_15498','BUILDING_13063',
				'BUILDING_13062','BUILDING_15479','BUILDING_15484','BUILDING_15469',# tresor
				'BUILDING_15475','BUILDING_15499']
	#alle objekte im grid umsetzen
	for io in int_objs:
		system.mark_for_script_use(io)
		x,y,z = objects.get_position(io)
		#print "reposition " + io 
		objects.set_position_free(io, x, y, 0.0, grid="BUILDING_BUNKER_SPRENGUNG_INTERIOR_GRID")
	objects.set_active_state("ZONE_3_BUILDING_13097", INACTIVE)

def destroy_building_bunker():
	#print "destroy building bunker"
	objects.set_active_state(object="ZONE_3_BUILDING_10532", state=INACTIVE)
	objects.set_active_state(object="BUILDING_BUNKER_SPRENGUNG", state=ACTIVE)
	#objects.set_immortal_state("ZONE_3_BUILDING_10532", True)
	objects.set_immortal_state("BUILDING_BUNKER_SPRENGUNG", True)
	# objects.set_position('ZONE_3_BUILDING_363', 505.48501586914062, 240.8) # sandsack verschoben original >>> 505.48501586914062, >>> 240.27565002441406
	
	if (not objects.is_destroyed("RATSKULLS BUNKER A")):
		objects.set_position('RATSKULLS BUNKER A' , 512.72, 239.14, 'BUILDING_BUNKER_SPRENGUNG_INTERIOR_GRID')
	if (not objects.is_destroyed("RATSKULLS BUNKER B")):
		objects.set_position('RATSKULLS BUNKER B' , 514.53, 239.12, 'BUILDING_BUNKER_SPRENGUNG_INTERIOR_GRID')
	if (not objects.is_destroyed("RATSKULLS BUNKER C")): 
		objects.set_position('RATSKULLS BUNKER C' , 516.54, 239.25, 'BUILDING_BUNKER_SPRENGUNG_INTERIOR_GRID')
	if (not objects.is_destroyed("RATSKULLS BUNKER D")):
		objects.set_position('RATSKULLS BUNKER D' , 516.59, 237.64, 'BUILDING_BUNKER_SPRENGUNG_INTERIOR_GRID')
	if (not objects.is_destroyed("RATSKULL_LEADER")):
		objects.set_position('RATSKULL_LEADER'    , 516.51, 236.16, 'BUILDING_BUNKER_SPRENGUNG_INTERIOR_GRID')
		
	objects.play_animation(
		object="BUILDING_BUNKER_SPRENGUNG",
		animation="ANIM_BUNKER_L_DESTROY",
		callback=[["ONEND",on_destroy_building_bunker_end],["ONSTART",on_destroy_building_bunker_start]])
	
def UnEquip_Weapon_Direct(char_id):
	if objects.has_attribute(char_id, 'slots'):
		if 'right_hand' in objects.get_attribute(char_id, 'slots'):
			if not ((objects.get_attribute(char_id, 'slots')['right_hand']) == None):
				#print 'debug_UnEquip_Weapon_Direct_right_hand', char_id, objects.get_attribute(char_id, 'slots')['right_hand']
				character.un_equip_direct(char_id, (objects.get_attribute(char_id, 'slots')['right_hand']))
		if 'left_hand' in objects.get_attribute(char_id, 'slots'):
			if not ((objects.get_attribute(char_id, 'slots')['left_hand']) == None):
				#print 'debug_UnEquip_Weapon_Direct_left_hand', char_id, objects.get_attribute(char_id, 'slots')['right_hand']
				character.un_equip_direct(char_id, (objects.get_attribute(char_id, 'slots')['left_hand']))
	return True

# ist in zz_2 beschrieben
def Is_Equip_Weapon(char_id):
	if objects.has_attribute(char_id, 'slots'):
		equ = objects.get_attribute(char_id, 'slots')
		if (equ['right_hand']):
			if objects.has_attribute(equ['right_hand'], 'weapon_type'):
				return True
		for id in objects.get_inventory_id_list(char_id):
			if objects.has_attribute(id, 'weapon_type'):
				character.equip_direct(char_id, id)
				return True
	elif not objects.has_attribute(char_id, 'slots'):
		for id in objects.get_inventory_id_list(char_id):
			if objects.has_attribute(id, 'weapon_type'):
				character.equip_direct(char_id, id)
				return True
	return False
	
def can_enter_building( character_id, building_id ):
	#nicht gesprengter bunker
	if building_id == "ZONE_3_BUILDING_10532" and not data().Stop_Ratskulls_All:
		if character_id in system.get_pcs():
			return False
	#gesprengter bunker
	if building_id == "BUILDING_BUNKER_SPRENGUNG":
		if character_id in system.get_pcs():
			return data().bunker_gesprengt
	
	return object_events.can_enter_building( character_id, building_id )
	
def InitChestsSafes():
	objects.add_closed_lock("BUILDING_15361", "lock1", closure_type='normal')
	objects.add_closed_lock("BUILDING_7796",  "lock1", closure_type='normal')
	objects.add_closed_lock("BUILDING_15363", "lock1", closure_type='booby-trap')
	objects.add_closed_lock("BUILDING_15366", "lock1", closure_type='normal')
	objects.add_closed_lock("BUILDING_15379", "lock1", closure_type='lock-trap')
	objects.add_closed_lock("BUILDING_15382", "lock1", closure_type='normal')
	objects.add_closed_lock("BUILDING_15411", "lock1", closure_type='booby-trap')
	objects.add_closed_lock("BUILDING_15439", "lock1", closure_type='poison-trap')
	objects.add_closed_lock("BUILDING_15440", "lock1", closure_type='normal')
	objects.add_closed_lock("BUILDING_15441", "lock1", closure_type='lock-trap')

def init_patch():
	if "ANIE" in system.get_npcs():
		if objects.is_active("ANIE"):
			data("zone_7.zone_7").anie_folgt = True

	if not hasattr(data(), "patch_jan"):
		objects.create_item_in_inventory("HAENDLER",["SET_WATER_SKIN","SET_WATER_SKIN","SET_WATER_SKIN","SET_WATER_SKIN"])
		objects.create_item_in_inventory(object="BUILDING_13064",equipment=["SET_AKSU74","SET_AMMOPACK_5_45_MM","SET_AMMOPACK_5_45_MM","SET_AMMOPACK_5_45_MM"])
		objects.create_item_in_inventory(object="BUILDING_15498",equipment=["SET_WALTER_PPK","SET_WALTER_PPK","SET_WALTER_PPK"])
		objects.create_item_in_inventory(object="BUILDING_13063",equipment=["SET_AMMOPACK_7_65_MM","SET_AMMOPACK_7_65_MM","SET_AMMOPACK_7_65_MM","SET_AMMOPACK_7_65_MM"])
		objects.create_item_in_inventory(object="BUILDING_13062",equipment=["SET_GIANT_KNIFE"])
		objects.create_item_in_inventory("HAENDLER",["SET_OINTMANT_JAR","SET_OINTMANT_JAR"])
		objects.create_item_in_inventory(object="BUILDING_7844",equipment=["SET_AMMOPACK_7_62_54_MMR"])
		
		objects.create_item_in_inventory(object='BUILDING_2921', equipment= ['SET_DART', 'SET_DART'] )
		objects.create_item_in_inventory(object='BUILDING_15411', equipment= 'SET_THROWING_KNIFE' )
		objects.create_item_in_inventory(object='BUILDING_7922', equipment= ['SET_SHURIKEN', 'SET_SHURIKEN'] )
		data().patch_jan = 4
	else:
		if not data().patch_jan:
			data().patch_jan = 1
			objects.create_item_in_inventory("HAENDLER",["SET_WATER_SKIN","SET_WATER_SKIN","SET_WATER_SKIN","SET_WATER_SKIN"])
			objects.create_item_in_inventory(object="BUILDING_13064",equipment=["SET_AKSU74","SET_AMMOPACK_5_45_MM","SET_AMMOPACK_5_45_MM","SET_AMMOPACK_5_45_MM"])
			objects.create_item_in_inventory(object="BUILDING_15498",equipment=["SET_WALTER_PPK","SET_WALTER_PPK","SET_WALTER_PPK"])
			objects.create_item_in_inventory(object="BUILDING_13063",equipment=["SET_AMMOPACK_7_65_MM","SET_AMMOPACK_7_65_MM","SET_AMMOPACK_7_65_MM","SET_AMMOPACK_7_65_MM"])
			objects.create_item_in_inventory(object="BUILDING_13062",equipment=["SET_GIANT_KNIFE"])
		if data().patch_jan < 2:
			data().patch_jan = 2
			objects.create_item_in_inventory("HAENDLER",["SET_OINTMANT_JAR","SET_OINTMANT_JAR"])
		if data().patch_jan < 3:
			data().patch_jan = 3
			# in Scheune auf Farm
			objects.create_item_in_inventory("BUILDING_7844","SET_AMMOPACK_7_62_54_MMR")
		if data().patch_jan < 4:
			data().patch_jan = 4
			objects.create_item_in_inventory(object='BUILDING_2921', equipment= ['SET_DART', 'SET_DART'] )
			objects.create_item_in_inventory(object='BUILDING_15411', equipment= 'SET_THROWING_KNIFE' )
			objects.create_item_in_inventory(object='BUILDING_7922', equipment= ['SET_SHURIKEN', 'SET_SHURIKEN'] )

	objects.set_attributes("DOERFLER A",
		model="low",
		gender="female",
		skin="white",
		clothes="ls_001",
		face="evil04")
	character.update_appearance("DOERFLER A")
	if (not data().spieler_hat_dietrich ):
		if(objects.exists("HERMAN")):
			if( not objects.count_in_inventory("HERMAN",data().obj_HermansPicklock) ):
				if not objects.is_in_inventory(data().obj_HermansPicklock):
					print "Dietrich missing"
					objects.pick_up_item_direct("HERMAN",data().obj_HermansPicklock)
				
	if system.get_qb_entry_state(data().QB_010) == UNCOMPLETE and system.get_qb_entry_state(data().QB_011) == UNCOMPLETE:
		system.set_qb_entry_state(data().QB_010,INACTIVE)
		
	time_ = system.get_mission_time().get_day_time()
	from timerepr import time
	if time('04:00:00') < time_:
		data().donald_schlaeft = False
	else:
		data().donald_schlaeft = True
	pass
	init_main_npcs()
	
	#restliche Tiere "scharf" machen
	for animal in ["HIRSCH_1","HIRSCH_2","HIRSCH_3","HIRSCH_4"]:
		if objects.exists(animal): # and not objects.is_destroyed(animal):
			objects.set_attribute(animal,"foes", ["UISPIELER"])
			
	if not objects.has_attribute("HAENDLER", "voice_id"):
		objects.set_attribute("HAENDLER", "voice_id", "trader_01")
		
	if 'HERMAN' in system.get_npcs():
		objects.set_immortal_state('HERMAN', True)
		
	if 'EINSIEDLER' in system.get_npcs():
		objects.set_immortal_state('EINSIEDLER', True)
	
	if 'GONZO' in system.get_npcs():
		if not objects.has_attribute('GONZO', 'foes'):
			objects.set_immortal_state('GONZO', True)
	
	if not hasattr(data('zone_3.zone_3'), 'Kuehe_Versezt'):
		data().Kuehe_Versezt = True
		objects.set_position("KUH_1", 256.33, 445.68, 'landscape')
		objects.set_position("KUH_2", 256.03, 432.96, 'landscape')
		objects.set_direction('KUH_2', 160)
		objects.set_position("KUH_3", 253.17, 439.44, 'landscape')
		objects.set_direction('KUH_3', 90)
	
	# Ptch fuer doppelten Destilerie eintrag
	if (system.get_qb_entry_state(data().QB_006) == UNCOMPLETE and 
		(system.get_qb_entry_state(data().QB_007) == COMPLETE or 
		system.get_qb_entry_state(data().QB_018) == UNCOMPLETE)):
			system.set_qb_entry_state(data().QB_006,INACTIVE )
	
	# Bison Leiche
	if not hasattr(data(),"Timer_Dead_Bison"):
		data().Timer_Dead_Bison = 30
		data().Timervalue_Dead_Bison = 5 * 1000
		
		data().mq_animal_ausgeweidet["DEAD_BISON"] = False
		if not data().mq_animal_ausgeweidet["ZONE_3_BUILDING_685"]:
			# Bison Leiche wird noch gebraucht
			data().Obj_BisonKadaver = "DEAD_BISON"
			objects.set_active_state("ZONE_3_BUILDING_685",False)
			system.create_animal(id="DEAD_BISON",	type=ANIMAL_BISON, party="ANIMALS", x=300, y=300)
			objects.destroy("DEAD_BISON")
			system.notify_timer(data().Timer_Dead_Bison, data().Timervalue_Dead_Bison)
			#objects.set_position("DEAD_BISON",302.5,328.3)
			#objects.set_direction("DEAD_BISON",270)
			
	for kuh in ['KUH1', 'KUH2', 'KUH3', 'KUH4']:
		objects.set_active_state(kuh, True)
		
	# neue Variablen für Ratskull abschalten
	if not hasattr(data(), 'Stop_Ratskulls_All'):
		data().Stop_Ratskulls_All = False
		data().Stop_Ratskulls_Distillery = False
		data().Timer_GeorgGenugGelegen_no_ratskulls = 30
		data().Bruch_Mit_Hayes = False
		data().Chest_Dialog_Played = False
		data().Chest_Cutscene_Grid = 'BUILDING_BUNKER_SPRENGUNG_INTERIOR_GRID'
		data().Second_Mine_Warning = False

	
def init_main_npcs():
	npcs = system.get_npcs()
	if 'HAENDLER' in npcs:
		character.set_main_quest_npc_state(char="HAENDLER", state=True)
	if 'LUKE_Z3' in npcs:
		character.set_main_quest_npc_state(char="LUKE_Z3", state=True)

def can_climb( character_id, object_id ):
	
	if object_id in WAFFENLAGER_ZAUN:
		return False
	else:
		return object_events.can_climb(character_id, object_id)
		
def rest_finished():
	update_tieger()
	if data().miapia_folgen:
		daily_routine.allow_activity('MIA')
		daily_routine.allow_activity('PIA')
	
def update_tieger():
	if not data().BergtigerDead:
		clock = system.get_mission_time().get_day_time()
		if (clock >= time("0:00:00") and clock < time("2:00:00")):
			pass # activierung wird vom timer übernommen
		else:
			spawnBergtigerin(INACTIVE)
	
def rest_started():
	if data().miapia_folgen:
		daily_routine.prohibit_activity('MIA')
		daily_routine.prohibit_activity('PIA')
	
def rest_canceled():
	if data().miapia_folgen:
		daily_routine.allow_activity('MIA')
		daily_routine.allow_activity('PIA')

################################################################################
#
#Ratskulls abschalten
#
################################################################################
def check_ratskulls_dead():
	if (hasattr(data("zone_5.zone_5"), 'phoenix_gesprochen') 
		and data("zone_5.zone_5").phoenix_gesprochen):
			if (not data().bunker_gesprengt and not data().Stop_Ratskulls_All):
				deactivate_ratskulls()
			
			if (system.get_qb_entry_state(data().QB_007) != COMPLETE and not data().Stop_Ratskulls_Distillery):
				deactivate_distillery()
			
			
			

def deactivate_ratskulls():
	data().Stop_Ratskulls_All = True
	
	#Minenfeld
	#wird auch durch data().Stop_Ratskulls_All geregelt
	
	#NPCs
	for id in RATSKULLS_BUNKER:
		if objects.is_alive_and_active(id):
			objects.set_active_state(id, False)
	
	#Bunker leer machen
	data().bunker_gesprengt = True
	objects.remove_closed_lock_by_name("ZONE_3_BUILDING_10532", "lock1")
	for chest_id in BUNKER_CHESTS:
		id_list = objects.get_inventory_id_list(chest_id)
		if id_list:
			for id in objects.get_inventory_id_list(chest_id):
				objects.transfer_item(chest_id,id,'HAENDLER')
	
	#Kühe abschalten und umstellen
	for id in data().Obj_Kuehe:
		if objects.is_alive_and_active(id):
			objects.cancel_commandos(id)
			objects.set_position(id, data().Pos_Kuehe[id][0], data().Pos_Kuehe[id][1])
		else:
			objects.set_active_state(id, False)
	
	#Pete umstellen und Tagesablauf aktivieren
	data().Georg_LiegtUnterTraktor = False
	objects.set_position("GEORG",385.7, 428.1)
	character.set_approachable_state('GEORG',True)
	daily_routine.allow_activity('GEORG')
	
	if objects.is_active("DONALD RUMS"):
		data().georg_d_126_spoken = True
		
	#Bunker umschalten
	#objects.set_active_state(object="ZONE_3_BUILDING_10532", state=INACTIVE)
	#objects.set_active_state(object="BUILDING_BUNKER_SPRENGUNG", state=ACTIVE)
	#objects.play_animation(
	#	object="BUILDING_BUNKER_SPRENGUNG",
	#	animation="ANIM_BUNKER_L_DESTROY",
	#	callback=["ONEND",on_destroy_building_bunker_end])
	
	#alle objekte im grid umsetzen
	int_objs = ['BUILDING_13069','BUILDING_13064','BUILDING_15498','BUILDING_13063',
				'BUILDING_13062','BUILDING_15479','BUILDING_15484','BUILDING_15469',# tresor
				'BUILDING_15475','BUILDING_15499']
	for io in int_objs:
		x,y,z = objects.get_position(io)
		objects.set_position_free(io, x, y, 0.0, grid="ZONE_3_BUILDING_10532_INTERIOR_GRID")
	
		data().Chest_Cutscene_Grid = 'ZONE_3_BUILDING_10532_INTERIOR_GRID'
	#clear Quests and special reactions
	#vieles zum dlg_064 verlegt
	#if (was_zone_entered("zone_2.zone_2") and system.get_qb_entry_state(data("zone_2.zone_2").QB_013) == UNCOMPLETE):
	#	#noch nicht mit Pete geredet
	#	system.set_qb_entry_state(data("zone_2.zone_2").QB_013,IMPOSSIBLE)
		
	#if system.get_qb_entry_state(data().QB_002) == UNCOMPLETE:
	#	system.set_qb_entry_state(data().QB_002, INACTIVE)
	#	system.set_qb_entry_state(data("zone_2.zone_2").QB_013,IMPOSSIBLE)
	#	daily_routine.allow_activity('MAGDA')
	
	#if system.get_qb_entry_state(data().QB_003) == UNCOMPLETE:
	#	system.set_qb_entry_state(data().QB_003, INACTIVE)
	#	system.set_qb_entry_state(data("zone_2.zone_2").QB_013,IMPOSSIBLE)
	
	
	if system.get_qb_entry_state(data().QB_004) == UNCOMPLETE:
		system.notify_region_entered(region="BunkerKommentar", partyid="UISPIELER")
		system.set_qb_entry_state(data().QB_004, INACTIVE)
		if (was_zone_entered("zone_2.zone_2") and system.get_qb_entry_state(data("zone_2.zone_2").QB_013) == UNCOMPLETE):
			system.set_qb_entry_state(data("zone_2.zone_2").QB_013,IMPOSSIBLE)
	
	
def deactivate_distillery():
	data().Stop_Ratskulls_Distillery = True
	#NPCs
	for id in RATSKULLS: # + ["DOERFLER A","DOERFLER B","DOERFLER C"]
		if objects.is_alive_and_active(id):
			objects.set_active_state(id, False)
	
	#Quest wurde angenommen; abschalten erstmal beim DA
	if system.get_qb_entry_state(data().QB_006) == UNCOMPLETE:
		pass
	if system.get_qb_entry_state(data().QB_007) == UNCOMPLETE:
		pass
			
	
def check_no_gno():
	if hasattr(data('zone_8.zone_8'),'BruchMitHayes') and data('zone_8.zone_8').BruchMitHayes and not data().Bruch_Mit_Hayes:
		data().Bruch_Mit_Hayes = True
		if (system.get_qb_entry_state(data().QB_010) == INACTIVE
				and system.get_qb_entry_state(data().QB_011) == INACTIVE
				and system.get_qb_entry_state(data().QB_012) == INACTIVE):
			for id in ['DORFBEWOHNERIN','LUISA','MIA','PIA']:
				objects.set_active_state(id,False)
		elif (system.get_qb_entry_state(data().QB_010) == UNCOMPLETE
				and system.get_qb_entry_state(data().QB_011) == INACTIVE
				and system.get_qb_entry_state(data().QB_012) == INACTIVE):
			system.set_qb_entry_state(data().QB_010, IMPOSSIBLE)
			for id in ['DORFBEWOHNERIN','LUISA','MIA','PIA']:
				objects.set_active_state(id,False)
			
		

